/**
* DevExtreme (animation/fx.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface animationConfig {
    /**
     */
    complete?: (($element: TElement, config: any) => any);
    /**
     */
    delay?: number;
    /**
     */
    direction?: 'bottom' | 'left' | 'right' | 'top';
    /**
     */
    duration?: number;
    /**
     */
    easing?: string;
    /**
     */
    from?: number | string | any;
    /**
     */
    staggerDelay?: number;
    /**
     */
    start?: (($element: TElement, config: any) => any);
    /**
     */
    to?: number | string | any;
    /**
     */
    type?: 'css' | 'fade' | 'fadeIn' | 'fadeOut' | 'pop' | 'slide' | 'slideIn' | 'slideOut';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
declare const fx: {
    /**
     */
    animate(element: Element, config: animationConfig): TPromise<void>;

    /**
     */
    isAnimating(element: Element): boolean;

    /**
     */
    stop(element: Element, jumpToEnd: boolean): void;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default fx;
