/**
* DevExtreme (animation/position.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
  TElement
} from '../core/element';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface positionConfig {
    /**
     */
    at?: 'bottom' | 'center' | 'left' | 'left bottom' | 'left top' | 'right' | 'right bottom' | 'right top' | 'top' | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: 'center' | 'left' | 'right',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: 'bottom' | 'center' | 'top'
    };
    /**
     */
    boundary?: string | TElement | Window;
    /**
     */
    boundaryOffset?: string | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
    };
    /**
     */
    collision?: 'fit' | 'fit flip' | 'fit flipfit' | 'fit none' | 'flip' | 'flip fit' | 'flip none' | 'flipfit' | 'flipfit fit' | 'flipfit none' | 'none' | 'none fit' | 'none flip' | 'none flipfit' | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: 'fit' | 'flip' | 'flipfit' | 'none',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: 'fit' | 'flip' | 'flipfit' | 'none'
    };
    /**
     */
    my?: 'bottom' | 'center' | 'left' | 'left bottom' | 'left top' | 'right' | 'right bottom' | 'right top' | 'top' | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: 'center' | 'left' | 'right',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: 'bottom' | 'center' | 'top'
    };
    /**
     */
    of?: string | TElement | Window;
    /**
     */
    offset?: string | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
    };
}
