/**
 * DevExtreme (cjs/renovation/ui/scroll_view/scrollable_utils.js)
 * Version: 21.1.0 (build 21089-0329)
 * Build date: Tue Mar 30 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.getElementWidth = getElementWidth;
exports.getElementHeight = getElementHeight;
exports.getElementStyle = getElementStyle;
exports.ensureLocation = ensureLocation;
exports.getBoundaryProps = getBoundaryProps;
exports.getContainerOffsetInternal = getContainerOffsetInternal;
exports.normalizeCoordinate = normalizeCoordinate;
exports.getPublicCoordinate = getPublicCoordinate;
exports.normalizeLocation = normalizeLocation;
exports.getElementLocation = getElementLocation;
exports.updateAllowedDirection = updateAllowedDirection;
exports.ScrollDirection = exports.SCROLLABLE_SCROLLBAR_CLASS = exports.SCROLLABLE_SCROLLBARS_ALWAYSVISIBLE = exports.SCROLLABLE_SCROLLBARS_HIDDEN = exports.SCROLLABLE_SCROLLBAR_SIMULATED = exports.SCROLLABLE_DISABLED_CLASS = exports.SCROLLVIEW_BOTTOM_POCKET_CLASS = exports.SCROLLVIEW_CONTENT_CLASS = exports.SCROLLABLE_CONTAINER_CLASS = exports.SCROLLABLE_WRAPPER_CLASS = exports.SCROLLABLE_CONTENT_CLASS = exports.SCROLLABLE_SIMULATED_CLASS = exports.DIRECTION_BOTH = exports.DIRECTION_HORIZONTAL = exports.DIRECTION_VERTICAL = exports.SCROLL_LINE_HEIGHT = void 0;
var _type = require("../../../core/utils/type");
var _scroll_rtl_behavior = _interopRequireDefault(require("../../../core/utils/scroll_rtl_behavior"));
var _inflector = require("../../../core/utils/inflector");
var _get_computed_style = _interopRequireDefault(require("../../utils/get_computed_style"));
var _type_conversion = require("../../utils/type_conversion");
var _common = require("../../../core/utils/common");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    return Constructor
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var SCROLL_LINE_HEIGHT = 40;
exports.SCROLL_LINE_HEIGHT = SCROLL_LINE_HEIGHT;
var DIRECTION_VERTICAL = "vertical";
exports.DIRECTION_VERTICAL = DIRECTION_VERTICAL;
var DIRECTION_HORIZONTAL = "horizontal";
exports.DIRECTION_HORIZONTAL = DIRECTION_HORIZONTAL;
var DIRECTION_BOTH = "both";
exports.DIRECTION_BOTH = DIRECTION_BOTH;
var SCROLLABLE_SIMULATED_CLASS = "dx-scrollable-simulated";
exports.SCROLLABLE_SIMULATED_CLASS = SCROLLABLE_SIMULATED_CLASS;
var SCROLLABLE_CONTENT_CLASS = "dx-scrollable-content";
exports.SCROLLABLE_CONTENT_CLASS = SCROLLABLE_CONTENT_CLASS;
var SCROLLABLE_WRAPPER_CLASS = "dx-scrollable-wrapper";
exports.SCROLLABLE_WRAPPER_CLASS = SCROLLABLE_WRAPPER_CLASS;
var SCROLLABLE_CONTAINER_CLASS = "dx-scrollable-container";
exports.SCROLLABLE_CONTAINER_CLASS = SCROLLABLE_CONTAINER_CLASS;
var SCROLLVIEW_CONTENT_CLASS = "dx-scrollview-content";
exports.SCROLLVIEW_CONTENT_CLASS = SCROLLVIEW_CONTENT_CLASS;
var SCROLLVIEW_BOTTOM_POCKET_CLASS = "dx-scrollview-bottom-pocket";
exports.SCROLLVIEW_BOTTOM_POCKET_CLASS = SCROLLVIEW_BOTTOM_POCKET_CLASS;
var SCROLLABLE_DISABLED_CLASS = "dx-scrollable-disabled";
exports.SCROLLABLE_DISABLED_CLASS = SCROLLABLE_DISABLED_CLASS;
var SCROLLABLE_SCROLLBAR_SIMULATED = "dx-scrollable-scrollbar-simulated";
exports.SCROLLABLE_SCROLLBAR_SIMULATED = SCROLLABLE_SCROLLBAR_SIMULATED;
var SCROLLABLE_SCROLLBARS_HIDDEN = "dx-scrollable-scrollbars-hidden";
exports.SCROLLABLE_SCROLLBARS_HIDDEN = SCROLLABLE_SCROLLBARS_HIDDEN;
var SCROLLABLE_SCROLLBARS_ALWAYSVISIBLE = "dx-scrollable-scrollbars-alwaysvisible";
exports.SCROLLABLE_SCROLLBARS_ALWAYSVISIBLE = SCROLLABLE_SCROLLBARS_ALWAYSVISIBLE;
var SCROLLABLE_SCROLLBAR_CLASS = "dx-scrollable-scrollbar";
exports.SCROLLABLE_SCROLLBAR_CLASS = SCROLLABLE_SCROLLBAR_CLASS;

function getElementWidth(element) {
    var _getElementComputedSt;
    return (0, _type_conversion.toNumber)(null === (_getElementComputedSt = (0, _get_computed_style.default)(element)) || void 0 === _getElementComputedSt ? void 0 : _getElementComputedSt.width)
}

function getElementHeight(element) {
    var _getElementComputedSt2;
    return (0, _type_conversion.toNumber)(null === (_getElementComputedSt2 = (0, _get_computed_style.default)(element)) || void 0 === _getElementComputedSt2 ? void 0 : _getElementComputedSt2.height)
}

function getElementStyle(name, element) {
    var computedStyle = (0, _get_computed_style.default)(element) || {};
    return computedStyle[name]
}

function ensureLocation(location) {
    if ((0, _type.isNumeric)(location)) {
        return {
            left: location,
            top: location
        }
    }
    return _extends({
        top: 0,
        left: 0
    }, location)
}

function getRelativeLocation(element) {
    var result = {
        top: 0,
        left: 0
    };
    var targetElement = element;
    while (!targetElement.matches(".".concat(SCROLLABLE_CONTENT_CLASS))) {
        result.top += targetElement.offsetTop;
        result.left += targetElement.offsetLeft;
        targetElement = targetElement.offsetParent
    }
    return result
}
var ScrollDirection = function() {
    function ScrollDirection(direction) {
        this.DIRECTION_HORIZONTAL = "horizontal";
        this.DIRECTION_VERTICAL = "vertical";
        this.DIRECTION_BOTH = "both";
        this.direction = null !== direction && void 0 !== direction ? direction : DIRECTION_VERTICAL
    }
    _createClass(ScrollDirection, [{
        key: "isHorizontal",
        get: function() {
            return this.direction === DIRECTION_HORIZONTAL || this.direction === DIRECTION_BOTH
        }
    }, {
        key: "isVertical",
        get: function() {
            return this.direction === DIRECTION_VERTICAL || this.direction === DIRECTION_BOTH
        }
    }, {
        key: "isBoth",
        get: function() {
            return this.direction === DIRECTION_BOTH
        }
    }]);
    return ScrollDirection
}();
exports.ScrollDirection = ScrollDirection;

function getMaxScrollOffset(dimension, containerRef) {
    return containerRef["scroll".concat((0, _inflector.camelize)(dimension, true))] - containerRef["client".concat((0, _inflector.camelize)(dimension, true))]
}

function getBoundaryProps(direction, scrollOffset, element) {
    var left = scrollOffset.left,
        top = scrollOffset.top;
    var boundaryProps = {};
    var _ScrollDirection = new ScrollDirection(direction),
        isHorizontal = _ScrollDirection.isHorizontal,
        isVertical = _ScrollDirection.isVertical;
    if (isHorizontal) {
        boundaryProps.reachedLeft = left <= 0;
        boundaryProps.reachedRight = Math.round(left) >= getMaxScrollOffset("width", element)
    }
    if (isVertical) {
        boundaryProps.reachedTop = top <= 0;
        boundaryProps.reachedBottom = top >= getMaxScrollOffset("height", element)
    }
    return boundaryProps
}

function getContainerOffsetInternal(element) {
    return {
        left: element.scrollLeft,
        top: element.scrollTop
    }
}

function getScrollBarSize(dimension, containerRef) {
    return containerRef["offset".concat(dimension)] - containerRef["client".concat(dimension)]
}

function needNormalizeCoordinate(prop, rtlEnabled) {
    return true === rtlEnabled && "left" === prop
}

function normalizeCoordinate(prop, coordinate, rtlEnabled) {
    return needNormalizeCoordinate(prop, rtlEnabled) && (0, _scroll_rtl_behavior.default)().positive ? -1 * coordinate : coordinate
}

function getPublicCoordinate(prop, coordinate, containerRef, rtlEnabled) {
    return needNormalizeCoordinate(prop, rtlEnabled) ? getMaxScrollOffset("width", containerRef) + normalizeCoordinate(prop, coordinate, rtlEnabled) : coordinate
}

function normalizeLocation(location, direction) {
    if ((0, _type.isPlainObject)(location)) {
        var left = (0, _common.ensureDefined)(location.left, location.x);
        var top = (0, _common.ensureDefined)(location.top, location.y);
        return {
            left: (0, _type.isDefined)(left) ? -left : void 0,
            top: (0, _type.isDefined)(top) ? -top : void 0
        }
    }
    var _ScrollDirection2 = new ScrollDirection(direction || "vertical"),
        isHorizontal = _ScrollDirection2.isHorizontal,
        isVertical = _ScrollDirection2.isVertical;
    return {
        left: isHorizontal ? -location : void 0,
        top: isVertical ? -location : void 0
    }
}

function getElementLocationInternal(element, prop, offset, direction, containerRef, rtlEnabled) {
    var dimension = direction === DIRECTION_VERTICAL ? "Height" : "Width";
    var relativeLocation = getRelativeLocation(element)[prop];
    var scrollBarSize = getScrollBarSize(dimension, containerRef);
    var containerSize = containerRef["offset".concat(dimension)];
    var elementOffset = element["offset".concat(dimension)];
    var offsetStart = offset[prop];
    var offsetEnd = offset[direction === DIRECTION_VERTICAL ? "bottom" : "right"] || 0;
    var containerLocation = normalizeCoordinate(prop, getContainerOffsetInternal(containerRef)[prop], rtlEnabled);
    if (relativeLocation < containerLocation + offsetStart) {
        if (elementOffset < containerSize - offsetStart - offsetEnd) {
            return relativeLocation - offsetStart
        }
        return relativeLocation + elementOffset - containerSize + offsetEnd + scrollBarSize
    }
    if (relativeLocation + elementOffset >= containerLocation + containerSize - offsetEnd - scrollBarSize) {
        if (elementOffset < containerSize - offsetStart - offsetEnd) {
            return relativeLocation + elementOffset + scrollBarSize - containerSize + offsetEnd
        }
        return relativeLocation - offsetStart
    }
    return containerLocation
}

function getElementLocation(element, offset, direction, containerRef, rtlEnabled) {
    var prop = direction === DIRECTION_VERTICAL ? "top" : "left";
    var location = normalizeCoordinate(prop, getElementLocationInternal(element, prop, offset, direction, containerRef, rtlEnabled), rtlEnabled);
    return getPublicCoordinate(prop, location, containerRef, rtlEnabled)
}

function updateAllowedDirection(allowedDirections, direction) {
    var _ScrollDirection3 = new ScrollDirection(direction),
        isBoth = _ScrollDirection3.isBoth,
        isHorizontal = _ScrollDirection3.isHorizontal,
        isVertical = _ScrollDirection3.isVertical;
    if (isBoth && allowedDirections.vertical && allowedDirections.horizontal) {
        return DIRECTION_BOTH
    }
    if (isHorizontal && allowedDirections.horizontal) {
        return DIRECTION_HORIZONTAL
    }
    if (isVertical && allowedDirections.vertical) {
        return DIRECTION_VERTICAL
    }
    return
}
