/**
 * DevExtreme (cjs/renovation/ui/scroll_view/top_pocket.js)
 * Version: 21.1.0 (build 21089-0329)
 * Build date: Tue Mar 30 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.TopPocket = exports.viewFunction = void 0;
var _inferno = require("inferno");
var _base_component = require("devextreme-generator/modules/inferno/base_component");
var _devices = _interopRequireDefault(require("../../../core/devices"));
var _type = require("../../../core/utils/type");
var _message = _interopRequireDefault(require("../../../localization/message"));
var _top_pocket_props = require("./top_pocket_props");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    return Constructor
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var SCROLLVIEW_TOP_POCKET_CLASS = "dx-scrollview-top-pocket";
var SCROLLVIEW_PULLDOWN = "dx-scrollview-pull-down";
var SCROLLVIEW_PULLDOWN_IMAGE_CLASS = "dx-scrollview-pull-down-image";
var SCROLLVIEW_PULLDOWN_INDICATOR_CLASS = "dx-scrollview-pull-down-indicator";
var SCROLLVIEW_PULLDOWN_TEXT_CLASS = "dx-scrollview-pull-down-text";
var SCROLLVIEW_PULLDOWN_VISIBLE_TEXT_CLASS = "dx-scrollview-pull-down-text-visible";

function getVisibleClass(currentState, expectedState) {
    return currentState === expectedState ? SCROLLVIEW_PULLDOWN_VISIBLE_TEXT_CLASS : void 0
}
var viewFunction = function(viewModel) {
    var pocketState = viewModel.pocketState,
        pulledDownText = viewModel.pulledDownText,
        pullingDownText = viewModel.pullingDownText,
        refreshStrategy = viewModel.refreshStrategy,
        refreshingText = viewModel.refreshingText;
    return (0, _inferno.createVNode)(1, "div", SCROLLVIEW_TOP_POCKET_CLASS, (0, _inferno.createVNode)(1, "div", SCROLLVIEW_PULLDOWN, [(0, _inferno.createVNode)(1, "div", SCROLLVIEW_PULLDOWN_IMAGE_CLASS), (0, _inferno.createVNode)(1, "div", SCROLLVIEW_PULLDOWN_INDICATOR_CLASS), (0, _inferno.createVNode)(1, "div", SCROLLVIEW_PULLDOWN_TEXT_CLASS, "swipeDown" !== refreshStrategy && (0, _inferno.createFragment)([(0, _inferno.createVNode)(1, "div", getVisibleClass(pocketState, _top_pocket_props.TopPocketState.STATE_RELEASED), pullingDownText, 0), (0, _inferno.createVNode)(1, "div", getVisibleClass(pocketState, _top_pocket_props.TopPocketState.STATE_READY), pulledDownText, 0), (0, _inferno.createVNode)(1, "div", getVisibleClass(pocketState, _top_pocket_props.TopPocketState.STATE_REFRESHING), refreshingText, 0)], 4), 0)], 4), 2)
};
exports.viewFunction = viewFunction;
var TopPocket = function(_BaseInfernoComponent) {
    _inheritsLoose(TopPocket, _BaseInfernoComponent);

    function TopPocket(props) {
        var _this;
        _this = _BaseInfernoComponent.call(this, props) || this;
        _this._currentState = null;
        _this.state = {
            pocketState: _top_pocket_props.TopPocketState.STATE_RELEASED
        };
        return _this
    }
    var _proto = TopPocket.prototype;
    _proto.set_pocketState = function(value) {
        var _this2 = this;
        this.setState((function(state) {
            _this2._currentState = state;
            var newValue = value();
            _this2._currentState = null;
            return {
                pocketState: newValue
            }
        }))
    };
    _proto.render = function() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            pocketState: this.pocketState,
            refreshStrategy: this.refreshStrategy,
            pullingDownText: this.pullingDownText,
            pulledDownText: this.pulledDownText,
            refreshingText: this.refreshingText,
            restAttributes: this.restAttributes
        })
    };
    _createClass(TopPocket, [{
        key: "pocketState",
        get: function() {
            var state = this._currentState || this.state;
            return state.pocketState
        }
    }, {
        key: "refreshStrategy",
        get: function() {
            return this.props.refreshStrategy || ("android" === _devices.default.real().platform ? "swipeDown" : "pullDown")
        }
    }, {
        key: "pullingDownText",
        get: function() {
            var pullingDownText = this.props.pullingDownText;
            if ((0, _type.isDefined)(pullingDownText)) {
                return pullingDownText
            }
            return _message.default.format("dxScrollView-pullingDownText")
        }
    }, {
        key: "pulledDownText",
        get: function() {
            var pulledDownText = this.props.pulledDownText;
            if ((0, _type.isDefined)(pulledDownText)) {
                return pulledDownText
            }
            return _message.default.format("dxScrollView-pulledDownText")
        }
    }, {
        key: "refreshingText",
        get: function() {
            var refreshingText = this.props.refreshingText;
            if ((0, _type.isDefined)(refreshingText)) {
                return refreshingText
            }
            return _message.default.format("dxScrollView-refreshingText")
        }
    }, {
        key: "restAttributes",
        get: function() {
            var _this$props = this.props,
                restProps = (_this$props.pulledDownText, _this$props.pullingDownText, _this$props.refreshStrategy, _this$props.refreshingText, _objectWithoutProperties(_this$props, ["pulledDownText", "pullingDownText", "refreshStrategy", "refreshingText"]));
            return restProps
        }
    }]);
    return TopPocket
}(_base_component.BaseInfernoComponent);
exports.TopPocket = TopPocket;
TopPocket.defaultProps = _extends({}, _top_pocket_props.TopPocketProps);
