/**
* DevExtreme (core/dom_component.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import Component, {
    ComponentOptions
} from './component';

import {
    Device
} from './devices';

import {
    TElement
} from './element';

import { TemplateManager } from './template_manager';
import { FunctionTemplate } from './templates/function_template';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface DOMComponentOptions<T = DOMComponent> extends ComponentOptions<T> {
    /**
     */
    bindingOptions?: any;
    /**
     */
    elementAttr?: any;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    onDisposing?: ((e: { component?: T, element?: TElement, model?: any }) => void);
    /**
     */
    onOptionChanged?: ((e: { component?: T, element?: TElement, model?: any, name?: string, fullName?: string, value?: any }) => void);
    /**
     */
    rtlEnabled?: boolean;
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class DOMComponent extends Component {
    constructor(element: TElement, options?: DOMComponentOptions);
    /**
     */
    static defaultOptions(rule: { device?: Device | Array<Device> | Function, options?: any }): void;
    /**
     */
    dispose(): void;
    /**
     */
    element(): TElement;
    /**
     */
    static getInstance(element: TElement<Element>): DOMComponent;

    $element(): TElement;
    _getTemplate(template: unknown): FunctionTemplate;
    _invalidate(): void;
    _refresh(): void;
    _templateManager: TemplateManager;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = DOMComponentOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = DOMComponentOptions;
