/**
* DevExtreme (core/utils/type.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function type(object: any): string;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isBoolean<T>(object: T): object is Extract<T, boolean>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isDate<T>(object: T): object is Extract<T, Date>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isString<T>(object: T): object is Extract<T, string>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function type(object: any): 'object' | 'array' | 'string' | 'date' | 'null';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isNumeric<T>(object: T): object is Extract<T, number>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isFunction<T>(object: T): object is Extract<T, Function>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isExponential<T>(object: T): object is Extract<T, number>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isDefined<T>(object: T): object is NonNullable<T>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isObject<T>(object: T): object is Extract<T, object>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isEmptyObject<T>(object: T): object is Extract<T, object>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isPlainObject<T>(object: T): object is Extract<T, object>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isPrimitive<T>(value: T): value is Exclude<T, Function>&Exclude<T, object>&Exclude<T, any[]>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isWindow<T>(object: T): object is Extract<T, Window & typeof globalThis>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isRenderer(object: any): boolean;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isPromise<T>(object: T): object is Extract<T, Promise<any>>;

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export declare function isDeferred(object: any): boolean;
