/**
* DevExtreme (data/abstract_store.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TPromise
} from '../core/utils/deferred';

import {
    LoadOptions
} from './load_options';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface StoreOptions<T = Store> {
    /**
     */
    errorHandler?: Function;
    /**
     */
    key?: string | Array<string>;
    /**
     */
    onInserted?: ((values: any, key: any | string | number) => void);
    /**
     */
    onInserting?: ((values: any) => void);
    /**
     */
    onLoaded?: ((result: Array<any>) => void);
    /**
     */
    onLoading?: ((loadOptions: LoadOptions) => void);
    /**
     */
    onModified?: Function;
    /**
     */
    onModifying?: Function;
    /**
     */
    onPush?: ((changes: Array<any>) => void);
    /**
     */
    onRemoved?: ((key: any | string | number) => void);
    /**
     */
    onRemoving?: ((key: any | string | number) => void);
    /**
     */
    onUpdated?: ((key: any | string | number, values: any) => void);
    /**
     */
    onUpdating?: ((key: any | string | number, values: any) => void);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class Store {
    constructor(options?: StoreOptions)
    /**
     */
    byKey(key: any | string | number): TPromise<any>;
    /**
     */
    insert(values: any): TPromise<any>;
    /**
     */
    key(): any;
    /**
     */
    keyOf(obj: any): any;
    /**
     */
    load(): TPromise<any>;
    /**
     */
    load(options: LoadOptions): TPromise<any>;
    /**
     */
    off(eventName: string): this;
    /**
     */
    off(eventName: string, eventHandler: Function): this;
    /**
     */
    on(eventName: string, eventHandler: Function): this;
    /**
     */
    on(events: any): this;
    /**
     */
    push(changes: Array<any>): void;
    /**
     */
    remove(key: any | string | number): TPromise<void>;
    /**
     */
    totalCount(obj: { filter?: any, group?: any }): TPromise<number>;
    /**
     */
    update(key: any | string | number, values: any): TPromise<any>;
}
