/**
* DevExtreme (data/query.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TPromise
} from '../core/utils/deferred';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Query {
    /**
     */
    aggregate(seed: any, step: Function, finalize: Function): TPromise<any>;
    /**
     */
    aggregate(step: Function): TPromise<any>;
    /**
     */
    avg(): TPromise<number>;
    /**
     */
    avg(getter: any): TPromise<number>;
    /**
     */
    count(): TPromise<number>;
    /**
     */
    enumerate(): TPromise<any>;
    /**
     */
    filter(criteria: Array<any>): Query;
    /**
     */
    filter(predicate: Function): Query;
    /**
     */
    groupBy(getter: any): Query;
    /**
     */
    max(): TPromise<number | Date>;
    /**
     */
    max(getter: any): TPromise<number | Date>;
    /**
     */
    min(): TPromise<number | Date>;
    /**
     */
    min(getter: any): TPromise<number | Date>;
    /**
     */
    select(getter: any): Query;
    /**
     */
    slice(skip: number, take?: number): Query;
    /**
     */
    sortBy(getter: any): Query;
    /**
     */
    sortBy(getter: any, desc: boolean): Query;
    /**
     */
    sum(): TPromise<number>;
    /**
     */
    sum(getter: any): TPromise<number>;
    /**
     */
    thenBy(getter: any): Query;
    /**
     */
    thenBy(getter: any, desc: boolean): Query;
    /**
     */
    toArray(): Array<any>;
}

/**
 * Creates a Query instance.
 */
declare function query(array: Array<any>): Query;

/**
 * Creates a Query instance that accesses a remote data service using its URL.
 */
declare function query(url: string, queryOptions: any): Query;


/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default query;
