/**
 * DevExtreme (esm/renovation/ui/scroll_view/bottom_pocket.js)
 * Version: 21.1.0 (build 21089-0329)
 * Build date: Tue Mar 30 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import {
    createVNode
} from "inferno";
import {
    BaseInfernoComponent
} from "devextreme-generator/modules/inferno/base_component";
import {
    isDefined
} from "../../../core/utils/type";
import {
    SCROLLVIEW_BOTTOM_POCKET_CLASS
} from "./scrollable_utils";
import messageLocalization from "../../../localization/message";
import {
    BottomPocketProps
} from "./bottom_pocket_props";
var SCROLLVIEW_REACHBOTTOM_CLASS = "dx-scrollview-scrollbottom";
var SCROLLVIEW_REACHBOTTOM_INDICATOR_CLASS = "dx-scrollview-scrollbottom-indicator";
var SCROLLVIEW_REACHBOTTOM_TEXT_CLASS = "dx-scrollview-scrollbottom-text";
export var viewFunction = viewModel => {
    var {
        reachBottomText: reachBottomText
    } = viewModel;
    return createVNode(1, "div", SCROLLVIEW_BOTTOM_POCKET_CLASS, createVNode(1, "div", SCROLLVIEW_REACHBOTTOM_CLASS, [createVNode(1, "div", SCROLLVIEW_REACHBOTTOM_INDICATOR_CLASS), createVNode(1, "div", SCROLLVIEW_REACHBOTTOM_TEXT_CLASS, createVNode(1, "div", null, reachBottomText, 0), 2)], 4), 2)
};
export class BottomPocket extends BaseInfernoComponent {
    constructor(props) {
        super(props);
        this.state = {}
    }
    get reachBottomText() {
        var {
            reachBottomText: reachBottomText
        } = this.props;
        if (isDefined(reachBottomText)) {
            return reachBottomText
        }
        return messageLocalization.format("dxScrollView-reachBottomText")
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, ["reachBottomText"]);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            reachBottomText: this.reachBottomText,
            restAttributes: this.restAttributes
        })
    }
}
BottomPocket.defaultProps = _extends({}, BottomPocketProps);
