/**
* DevExtreme (file_management/remote_provider.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import FileSystemProviderBase, {
    FileSystemProviderBaseOptions
} from './provider_base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface RemoteFileSystemProviderOptions extends FileSystemProviderBaseOptions<RemoteFileSystemProvider> {
    /**
     */
    beforeAjaxSend?: ((options: { headers?: any, xhrFields?: any, formData?: any }) => any);
    /**
     */
    beforeSubmit?: ((options: { formData?: any }) => any);
    /**
     */
    endpointUrl?: string;
    /**
     */
    hasSubDirectoriesExpr?: string | Function;
    /**
     */
    requestHeaders?: any;
}
/**
 */
export default class RemoteFileSystemProvider extends FileSystemProviderBase {
    constructor(options?: RemoteFileSystemProviderOptions)
}
