/**
* DevExtreme (ui/accordion.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    TPromise
} from '../core/utils/deferred';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    TEvent
} from '../events/index';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxAccordionOptions extends CollectionWidgetOptions<dxAccordion> {
    /**
     */
    animationDuration?: number;
    /**
     */
    collapsible?: boolean;
    /**
     */
    dataSource?: string | Array<string | dxAccordionItem | any> | DataSource | DataSourceOptions;
    /**
     */
    deferRendering?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    itemTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    itemTitleTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    items?: Array<string | dxAccordionItem | any>;
    /**
     */
    multiple?: boolean;
    /**
     */
    onItemTitleClick?: ((e: { component?: dxAccordion, element?: TElement, model?: any, itemData?: any, itemElement?: TElement, itemIndex?: number, event?: TEvent }) => void) | string;
    /**
     */
    repaintChangesOnly?: boolean;
    /**
     */
    selectedIndex?: number;
}
/**
 */
export default class dxAccordion extends CollectionWidget {
    constructor(element: TElement, options?: dxAccordionOptions)
    /**
     */
    collapseItem(index: number): TPromise<void>;
    /**
     */
    expandItem(index: number): TPromise<void>;
    /**
     */
    updateDimensions(): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxAccordionItem extends CollectionWidgetItem {
    /**
     */
    icon?: string;
    /**
     */
    title?: string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxAccordionOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxAccordionOptions;
