/**
* DevExtreme (ui/action_sheet.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    TEvent
} from '../events/index';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxActionSheetOptions extends CollectionWidgetOptions<dxActionSheet> {
    /**
     */
    cancelText?: string;
    /**
     */
    dataSource?: string | Array<string | dxActionSheetItem | any> | DataSource | DataSourceOptions;
    /**
     */
    items?: Array<string | dxActionSheetItem | any>;
    /**
     */
    onCancelClick?: ((e: { component?: dxActionSheet, element?: TElement, model?: any, cancel?: boolean }) => void) | string;
    /**
     */
    showCancelButton?: boolean;
    /**
     */
    showTitle?: boolean;
    /**
     */
    target?: string | TElement;
    /**
     */
    title?: string;
    /**
     */
    usePopover?: boolean;
    /**
     */
    visible?: boolean;
}
/**
 */
export default class dxActionSheet extends CollectionWidget {
    constructor(element: TElement, options?: dxActionSheetOptions)
    /**
     */
    hide(): TPromise<void>;
    /**
     */
    show(): TPromise<void>;
    /**
     */
    toggle(showing: boolean): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxActionSheetItem extends CollectionWidgetItem {
    /**
     */
    icon?: string;
    /**
     */
    onClick?: ((e: { component?: dxActionSheet, element?: TElement, model?: any, event?: TEvent }) => void) | string;
    /**
     */
    type?: 'back' | 'danger' | 'default' | 'normal' | 'success';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxActionSheetOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxActionSheetOptions;
