/**
* DevExtreme (ui/autocomplete.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import dxDropDownList, {
    dxDropDownListOptions
} from './drop_down_editor/ui.drop_down_list';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxAutocompleteOptions extends dxDropDownListOptions<dxAutocomplete> {
    /**
     */
    maxItemCount?: number;
    /**
     */
    minSearchLength?: number;
    /**
     */
    showDropDownButton?: boolean;
    /**
     */
    value?: string;
}
/**
 */
export default class dxAutocomplete extends dxDropDownList {
    constructor(element: TElement, options?: dxAutocompleteOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxAutocompleteOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxAutocompleteOptions;
