/**
* DevExtreme (ui/button.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    TEvent
} from '../events/index';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxButtonOptions extends WidgetOptions<dxButton> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    icon?: string;
    /**
     */
    onClick?: ((e: { component?: dxButton, element?: TElement, model?: any, event?: TEvent, validationGroup?: any }) => void);
    /**
     */
    stylingMode?: 'text' | 'outlined' | 'contained';
    /**
     */
    template?: template | ((buttonData: { text?: string, icon?: string }, contentElement: TElement) => string | TElement);
    /**
     */
    text?: string;
    /**
     */
    type?: 'back' | 'danger' | 'default' | 'normal' | 'success';
    /**
     */
    useSubmitBehavior?: boolean;
    /**
     */
    validationGroup?: string;
}
/**
 */
export default class dxButton extends Widget {
    constructor(element: TElement, options?: dxButtonOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxButtonOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxButtonOptions;
