/**
* DevExtreme (ui/button_group.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    TEvent
} from '../events/index';

import {
    CollectionWidgetItem
} from './collection/ui.collection_widget.base';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxButtonGroupOptions extends WidgetOptions<dxButtonGroup> {
    /**
     */
    buttonTemplate?: template | ((buttonData: any, buttonContent: TElement) => string | TElement);
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    items?: Array<dxButtonGroupItem>;
    /**
     */
    keyExpr?: string | Function;
    /**
     */
    onItemClick?: ((e: { component?: dxButtonGroup, element?: TElement, model?: any, itemData?: any, itemElement?: TElement, itemIndex?: number, event?: TEvent }) => void);
    /**
     */
    onSelectionChanged?: ((e: { component?: dxButtonGroup, element?: TElement, model?: any, addedItems?: Array<any>, removedItems?: Array<any> }) => void);
    /**
     */
    selectedItemKeys?: Array<any>;
    /**
     */
    selectedItems?: Array<any>;
    /**
     */
    selectionMode?: 'multiple' | 'single';
    /**
     */
    stylingMode?: 'text' | 'outlined' | 'contained';
}
/**
 */
export default class dxButtonGroup extends Widget {
    constructor(element: TElement, options?: dxButtonGroupOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxButtonGroupItem extends CollectionWidgetItem {
    /**
     */
    hint?: string;
    /**
     */
    icon?: string;
    /**
     */
    type?: 'back' | 'danger' | 'default' | 'normal' | 'success';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxButtonGroupOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxButtonGroupOptions;
