/**
* DevExtreme (ui/calendar.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import Editor, {
    EditorOptions
} from './editor/editor';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxCalendarOptions extends EditorOptions<dxCalendar> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    cellTemplate?: template | ((itemData: { date?: Date, view?: string, text?: string }, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    dateSerializationFormat?: string;
    /**
     */
    disabledDates?: Array<Date> | ((data: { component?: any, date?: Date, view?: string }) => boolean);
    /**
     */
    firstDayOfWeek?: 0 | 1 | 2 | 3 | 4 | 5 | 6;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    max?: Date | number | string;
    /**
     */
    maxZoomLevel?: 'century' | 'decade' | 'month' | 'year';
    /**
     */
    min?: Date | number | string;
    /**
     */
    minZoomLevel?: 'century' | 'decade' | 'month' | 'year';
    /**
     */
    name?: string;
    /**
     */
    showTodayButton?: boolean;
    /**
     */
    value?: Date | number | string;
    /**
     */
    zoomLevel?: 'century' | 'decade' | 'month' | 'year';
}
/**
 */
export default class dxCalendar extends Editor {
    constructor(element: TElement, options?: dxCalendarOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxCalendarOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxCalendarOptions;
