/**
* DevExtreme (ui/check_box.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import Editor, {
    EditorOptions
} from './editor/editor';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxCheckBoxOptions extends EditorOptions<dxCheckBox> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    name?: string;
    /**
     */
    text?: string;
    /**
     */
    value?: boolean | undefined;
}
/**
 */
export default class dxCheckBox extends Editor {
    constructor(element: TElement, options?: dxCheckBoxOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxCheckBoxOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxCheckBoxOptions;
