/**
* DevExtreme (ui/context_menu.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    positionConfig
} from '../animation/position';

import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    TEvent
} from '../events/index';

import dxMenuBase, {
    dxMenuBaseOptions
} from './context_menu/ui.menu_base';

import {
    dxMenuBaseItem
} from './menu';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxContextMenuOptions extends dxMenuBaseOptions<dxContextMenu> {
    /**
     */
    closeOnOutsideClick?: boolean | ((event: TEvent) => boolean);
    /**
     */
    dataSource?: string | Array<dxContextMenuItem> | DataSource | DataSourceOptions;
    /**
     */
    items?: Array<dxContextMenuItem>;
    /**
     */
    onHidden?: ((e: { component?: dxContextMenu, element?: TElement, model?: any }) => void);
    /**
     */
    onHiding?: ((e: { component?: dxContextMenu, element?: TElement, model?: any, cancel?: boolean }) => void);
    /**
     */
    onPositioning?: ((e: { component?: dxContextMenu, element?: TElement, model?: any, event?: TEvent, position?: positionConfig }) => void);
    /**
     */
    onShowing?: ((e: { component?: dxContextMenu, element?: TElement, model?: any, cancel?: boolean }) => void);
    /**
     */
    onShown?: ((e: { component?: dxContextMenu, element?: TElement, model?: any }) => void);
    /**
     */
    position?: positionConfig;
    /**
     */
    showEvent?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      delay?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      name?: string
    } | string;
    /**
     */
    submenuDirection?: 'auto' | 'left' | 'right';
    /**
     */
    target?: string | TElement;
    /**
     */
    visible?: boolean;
}
/**
 */
export default class dxContextMenu extends dxMenuBase {
    constructor(element: TElement, options?: dxContextMenuOptions)
    /**
     */
    hide(): TPromise<void>;
    /**
     */
    show(): TPromise<void>;
    /**
     */
    toggle(showing: boolean): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxContextMenuItem extends dxMenuBaseItem {
    /**
     */
    items?: Array<dxContextMenuItem>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxContextMenuOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxContextMenuOptions;
