/**
* DevExtreme (ui/date_box.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    dxCalendarOptions
} from './calendar';

import dxDropDownEditor, {
    dxDropDownEditorOptions
} from './drop_down_editor/ui.drop_down_editor';

import {
    format
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDateBoxOptions extends dxDropDownEditorOptions<dxDateBox> {
    /**
     */
    adaptivityEnabled?: boolean;
    /**
     */
    applyButtonText?: string;
    /**
     */
    calendarOptions?: dxCalendarOptions;
    /**
     */
    cancelButtonText?: string;
    /**
     */
    dateOutOfRangeMessage?: string;
    /**
     */
    dateSerializationFormat?: string;
    /**
     */
    disabledDates?: Array<Date> | ((data: { component?: dxDateBox, date?: Date, view?: string }) => boolean);
    /**
     */
    displayFormat?: format;
    /**
     */
    interval?: number;
    /**
     */
    invalidDateMessage?: string;
    /**
     */
    max?: Date | number | string;
    /**
     */
    min?: Date | number | string;
    /**
     */
    pickerType?: 'calendar' | 'list' | 'native' | 'rollers';
    /**
     */
    placeholder?: string;
    /**
     */
    showAnalogClock?: boolean;
    /**
     */
    type?: 'date' | 'datetime' | 'time';
    /**
     */
    useMaskBehavior?: boolean;
    /**
     */
    value?: Date | number | string;
}
/**
 */
export default class dxDateBox extends dxDropDownEditor {
    constructor(element: TElement, options?: dxDateBoxOptions)
    /**
     */
    close(): void;
    /**
     */
    open(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDateBoxOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDateBoxOptions;
