/**
* DevExtreme (ui/defer_rendering.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    animationConfig
} from '../animation/fx';

import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDeferRenderingOptions extends WidgetOptions<dxDeferRendering> {
    /**
     */
    animation?: animationConfig;
    /**
     */
    onRendered?: ((e: { component?: dxDeferRendering, element?: TElement, model?: any }) => void);
    /**
     */
    onShown?: ((e: { component?: dxDeferRendering, element?: TElement, model?: any }) => void);
    /**
     */
    renderWhen?: TPromise<void> | boolean;
    /**
     */
    showLoadIndicator?: boolean;
    /**
     */
    staggerItemSelector?: string;
}
/**
 */
export default class dxDeferRendering extends Widget {
    constructor(element: TElement, options?: dxDeferRenderingOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDeferRenderingOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDeferRenderingOptions;
