/**
* DevExtreme (ui/diagram.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramOptions extends WidgetOptions<dxDiagram> {
    /**
     */
    autoZoomMode?: 'fitContent' | 'fitWidth' | 'disabled';
    /**
     */
    contextMenu?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      commands?: Array<'separator'|'exportSvg'|'exportPng'|'exportJpg'|'undo'|'redo'|'cut'|'copy'|'paste'|'selectAll'|'delete'|'fontName'|'fontSize'|'bold'|'italic'|'underline'|'fontColor'|'lineColor'|'fillColor'|'textAlignLeft'|'textAlignCenter'|'textAlignRight'|'lock'|'unlock'|'sendToBack'|'bringToFront'|'insertShapeImage'|'editShapeImage'|'deleteShapeImage'|'connectorLineType'|'connectorLineStart'|'connectorLineEnd'|'layoutTreeTopToBottom'|'layoutTreeBottomToTop'|'layoutTreeLeftToRight'|'layoutTreeRightToLeft'|'layoutLayeredTopToBottom'|'layoutLayeredBottomToTop'|'layoutLayeredLeftToRight'|'layoutLayeredRightToLeft'|'fullScreen'|'zoomLevel'|'showGrid'|'snapToGrid'|'gridSize'|'units'|'pageSize'|'pageOrientation'|'pageColor'|'simpleView'|'toolbox'>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      enabled?: boolean
    };
    /**
     */
    contextToolbox?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      category?: 'general' | 'flowchart' | 'orgChart' | 'containers' | 'custom' | string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      displayMode?: 'icons' | 'texts',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      enabled?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapeIconsPerRow?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapes?: Array<'text' | 'rectangle' | 'ellipse' | 'cross' | 'triangle' | 'diamond' | 'heart' | 'pentagon' | 'hexagon' | 'octagon' | 'star' | 'arrowLeft' | 'arrowTop' | 'arrowRight' | 'arrowBottom' | 'arrowNorthSouth' | 'arrowEastWest' | 'process' | 'decision' | 'terminator' | 'predefinedProcess' | 'document' | 'multipleDocuments' | 'manualInput' | 'preparation' | 'data' | 'database' | 'hardDisk' | 'internalStorage' | 'paperTape' | 'manualOperation' | 'delay' | 'storedData' | 'display' | 'merge' | 'connector' | 'or' | 'summingJunction' | 'verticalContainer' | 'horizontalContainer' | 'cardWithImageOnLeft' | 'cardWithImageOnTop' | 'cardWithImageOnRight'> | Array<string>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    onCustomCommand?: ((e: { component?: dxDiagram, element?: TElement, name?: string }) => void);
    /**
     */
    customShapeTemplate?: template | ((container: TElement<SVGElement>, data: { item?: dxDiagramShape }) => any);
    /**
     */
    customShapeToolboxTemplate?: template | ((container: TElement<SVGElement>, data: { item?: dxDiagramShape }) => any);
    /**
     */
    customShapes?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowEditImage?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowEditText?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowResize?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      backgroundImageHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      backgroundImageLeft?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      backgroundImageTop?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      backgroundImageUrl?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      backgroundImageToolboxUrl?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      backgroundImageWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      baseType?: 'text' | 'rectangle' | 'ellipse' | 'cross' | 'triangle' | 'diamond' | 'heart' | 'pentagon' | 'hexagon' | 'octagon' | 'star' | 'arrowLeft' | 'arrowTop' | 'arrowRight' | 'arrowBottom' | 'arrowNorthSouth' | 'arrowEastWest' | 'process' | 'decision' | 'terminator' | 'predefinedProcess' | 'document' | 'multipleDocuments' | 'manualInput' | 'preparation' | 'data' | 'database' | 'hardDisk' | 'internalStorage' | 'paperTape' | 'manualOperation' | 'delay' | 'storedData' | 'display' | 'merge' | 'connector' | 'or' | 'summingJunction' | 'verticalContainer' | 'horizontalContainer' | 'cardWithImageOnLeft' | 'cardWithImageOnTop' | 'cardWithImageOnRight' | string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      category?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      connectionPoints?: Array<{
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        x?: number,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        y?: number
      }>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      defaultHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      defaultImageUrl?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      defaultText?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      defaultWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      imageHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      imageLeft?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      imageTop?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      imageWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keepRatioOnAutoSize?: boolean
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      maxHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      maxWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      minHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      minWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      template?: template | ((container: TElement<SVGElement>, data: { item?: dxDiagramShape }) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      templateHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      templateLeft?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      templateTop?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      templateWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textLeft?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textTop?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      title?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      toolboxTemplate?: template | ((container: TElement<SVGElement>, data: { item?: dxDiagramShape }) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      toolboxWidthToHeightRatio?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      type?: string
    }>;
    /**
     */
    defaultItemProperties?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      style?: Object,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textStyle?: Object,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      connectorLineType?: 'straight' | 'orthogonal',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      connectorLineStart?: 'none' | 'arrow' | 'outlinedTriangle' | 'filledTriangle',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      connectorLineEnd?: 'none' | 'arrow' | 'outlinedTriangle' | 'filledTriangle',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapeMinWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapeMaxWidth?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapeMinHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapeMaxHeight?: number
    };
    /**
     */
    editing?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowAddShape?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowDeleteShape?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowDeleteConnector?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowChangeConnection?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowChangeConnectorPoints?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowChangeConnectorText?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowChangeShapeText?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowResizeShape?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowMoveShape?: boolean
    };
    /**
     */
    edges?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      customDataExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataSource?: Array<any> | DataSource | DataSourceOptions,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      fromExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      fromLineEndExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      fromPointIndexExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keyExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      lineTypeExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      lockedExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      pointsExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      styleExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textStyleExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      toExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      toLineEndExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      toPointIndexExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      zIndexExpr?: string | ((data: any) => any)
    };
    /**
     */
    export?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      fileName?: string,
      /**
       * @deprecated
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      proxyUrl?: string
    };
    /**
     */
    fullScreen?: boolean;
    /**
     */
    gridSize?: number | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      items?: Array<number>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      value?: number
    };
    /**
     */
    nodes?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      autoLayout?: 'off' | 'tree' | 'layered' | {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        orientation?: 'vertical' | 'horizontal',
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        type?: 'off' | 'tree' | 'layered'
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      autoSizeEnabled?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      containerChildrenExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      containerKeyExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      customDataExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataSource?: Array<any> | DataSource | DataSourceOptions,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      heightExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      imageUrlExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      itemsExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keyExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      leftExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      lockedExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      parentKeyExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      styleExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textStyleExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      topExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      typeExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      widthExpr?: string | ((data: any) => any),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      zIndexExpr?: string | ((data: any) => any)
    };
    /**
     */
    hasChanges?: boolean;
    /**
     */
    onItemClick?: ((e: { component?: dxDiagram, element?: TElement, model?: any, item?: dxDiagramItem }) => void);
    /**
     */
    onItemDblClick?: ((e: { component?: dxDiagram, element?: TElement, model?: any, item?: dxDiagramItem }) => void);
    /**
     */
    onSelectionChanged?: ((e: { component?: dxDiagram, element?: TElement, model?: any, items?: Array<dxDiagramItem> }) => void);
    /**
     */
    onRequestEditOperation?: ((e: { component?: dxDiagram, element?: TElement, model?: any, operation?: 'addShape' | 'addShapeFromToolbox' | 'deleteShape' | 'deleteConnector' | 'changeConnection' | 'changeConnectorPoints', args?: dxDiagramAddShapeArgs|dxDiagramAddShapeFromToolboxArgs|dxDiagramDeleteShapeArgs|dxDiagramDeleteConnectorArgs|dxDiagramChangeConnectionArgs|dxDiagramChangeConnectorPointsArgs|dxDiagramBeforeChangeShapeTextArgs|dxDiagramChangeShapeTextArgs|dxDiagramBeforeChangeConnectorTextArgs|dxDiagramChangeConnectorTextArgs|dxDiagramResizeShapeArgs|dxDiagramMoveShapeArgs, reason?: 'checkUIElementAvailability' | 'modelModification', allowed?: boolean }) => void);
    /**
     */
    onRequestLayoutUpdate?: ((e: { component?: dxDiagram, element?: TElement, model?: any, changes?: any[], allowed?: boolean }) => void);
    /**
     */
    pageColor?: string;
    /**
     */
    pageOrientation?: 'portrait' | 'landscape';
    /**
     */
    pageSize?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      height?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      items?: Array<{
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        height?: number,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        text?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        width?: number
      }>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    propertiesPanel?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      tabs?: Array<{
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        commands?: Array<'separator'|'exportSvg'|'exportPng'|'exportJpg'|'undo'|'redo'|'cut'|'copy'|'paste'|'selectAll'|'delete'|'fontName'|'fontSize'|'bold'|'italic'|'underline'|'fontColor'|'lineColor'|'fillColor'|'textAlignLeft'|'textAlignCenter'|'textAlignRight'|'lock'|'unlock'|'sendToBack'|'bringToFront'|'insertShapeImage'|'editShapeImage'|'deleteShapeImage'|'connectorLineType'|'connectorLineStart'|'connectorLineEnd'|'layoutTreeTopToBottom'|'layoutTreeBottomToTop'|'layoutTreeLeftToRight'|'layoutTreeRightToLeft'|'layoutLayeredTopToBottom'|'layoutLayeredBottomToTop'|'layoutLayeredLeftToRight'|'layoutLayeredRightToLeft'|'fullScreen'|'zoomLevel'|'showGrid'|'snapToGrid'|'gridSize'|'units'|'pageSize'|'pageOrientation'|'pageColor'|'simpleView'|'toolbox'>,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        groups?: Array<{
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          commands?: Array<'separator'|'exportSvg'|'exportPng'|'exportJpg'|'undo'|'redo'|'cut'|'copy'|'paste'|'selectAll'|'delete'|'fontName'|'fontSize'|'bold'|'italic'|'underline'|'fontColor'|'lineColor'|'fillColor'|'textAlignLeft'|'textAlignCenter'|'textAlignRight'|'lock'|'unlock'|'sendToBack'|'bringToFront'|'insertShapeImage'|'editShapeImage'|'deleteShapeImage'|'connectorLineType'|'connectorLineStart'|'connectorLineEnd'|'layoutTreeTopToBottom'|'layoutTreeBottomToTop'|'layoutTreeLeftToRight'|'layoutTreeRightToLeft'|'layoutLayeredTopToBottom'|'layoutLayeredBottomToTop'|'layoutLayeredLeftToRight'|'layoutLayeredRightToLeft'|'fullScreen'|'zoomLevel'|'showGrid'|'snapToGrid'|'gridSize'|'units'|'pageSize'|'pageOrientation'|'pageColor'|'simpleView'|'toolbox'>,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          title?: string
        }>,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        title?: string
      }>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visibility?: 'auto' | 'visible' | 'collapsed' | 'disabled'
    };
    /**
     */
    readOnly?: boolean;
    /**
     */
    showGrid?: boolean;
    /**
     */
    simpleView?: boolean;
    /**
     */
    snapToGrid?: boolean;
    /**
     */
    mainToolbar?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      commands?: Array<'separator'|'exportSvg'|'exportPng'|'exportJpg'|'undo'|'redo'|'cut'|'copy'|'paste'|'selectAll'|'delete'|'fontName'|'fontSize'|'bold'|'italic'|'underline'|'fontColor'|'lineColor'|'fillColor'|'textAlignLeft'|'textAlignCenter'|'textAlignRight'|'lock'|'unlock'|'sendToBack'|'bringToFront'|'insertShapeImage'|'editShapeImage'|'deleteShapeImage'|'connectorLineType'|'connectorLineStart'|'connectorLineEnd'|'layoutTreeTopToBottom'|'layoutTreeBottomToTop'|'layoutTreeLeftToRight'|'layoutTreeRightToLeft'|'layoutLayeredTopToBottom'|'layoutLayeredBottomToTop'|'layoutLayeredLeftToRight'|'layoutLayeredRightToLeft'|'fullScreen'|'zoomLevel'|'showGrid'|'snapToGrid'|'gridSize'|'units'|'pageSize'|'pageOrientation'|'pageColor'|'simpleView'|'toolbox'>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visible?: boolean
    };
    /**
     */
    historyToolbar?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      commands?: Array<'separator'|'exportSvg'|'exportPng'|'exportJpg'|'undo'|'redo'|'cut'|'copy'|'paste'|'selectAll'|'delete'|'fontName'|'fontSize'|'bold'|'italic'|'underline'|'fontColor'|'lineColor'|'fillColor'|'textAlignLeft'|'textAlignCenter'|'textAlignRight'|'lock'|'unlock'|'sendToBack'|'bringToFront'|'insertShapeImage'|'editShapeImage'|'deleteShapeImage'|'connectorLineType'|'connectorLineStart'|'connectorLineEnd'|'layoutTreeTopToBottom'|'layoutTreeBottomToTop'|'layoutTreeLeftToRight'|'layoutTreeRightToLeft'|'layoutLayeredTopToBottom'|'layoutLayeredBottomToTop'|'layoutLayeredLeftToRight'|'layoutLayeredRightToLeft'|'fullScreen'|'zoomLevel'|'showGrid'|'snapToGrid'|'gridSize'|'units'|'pageSize'|'pageOrientation'|'pageColor'|'simpleView'|'toolbox'>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visible?: boolean
    };
    /**
     */
    viewToolbar?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      commands?: Array<'separator'|'exportSvg'|'exportPng'|'exportJpg'|'undo'|'redo'|'cut'|'copy'|'paste'|'selectAll'|'delete'|'fontName'|'fontSize'|'bold'|'italic'|'underline'|'fontColor'|'lineColor'|'fillColor'|'textAlignLeft'|'textAlignCenter'|'textAlignRight'|'lock'|'unlock'|'sendToBack'|'bringToFront'|'insertShapeImage'|'editShapeImage'|'deleteShapeImage'|'connectorLineType'|'connectorLineStart'|'connectorLineEnd'|'layoutTreeTopToBottom'|'layoutTreeBottomToTop'|'layoutTreeLeftToRight'|'layoutTreeRightToLeft'|'layoutLayeredTopToBottom'|'layoutLayeredBottomToTop'|'layoutLayeredLeftToRight'|'layoutLayeredRightToLeft'|'fullScreen'|'zoomLevel'|'showGrid'|'snapToGrid'|'gridSize'|'units'|'pageSize'|'pageOrientation'|'pageColor'|'simpleView'|'toolbox'>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visible?: boolean
    };
    /**
     */
    toolbox?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      groups?: Array<{
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        category?: 'general' | 'flowchart' | 'orgChart' | 'containers' | 'custom' | string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        displayMode?: 'icons' | 'texts',
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        expanded?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        shapes?: Array<'text' | 'rectangle' | 'ellipse' | 'cross' | 'triangle' | 'diamond' | 'heart' | 'pentagon' | 'hexagon' | 'octagon' | 'star' | 'arrowLeft' | 'arrowTop' | 'arrowRight' | 'arrowBottom' | 'arrowNorthSouth' | 'arrowEastWest' | 'process' | 'decision' | 'terminator' | 'predefinedProcess' | 'document' | 'multipleDocuments' | 'manualInput' | 'preparation' | 'data' | 'database' | 'hardDisk' | 'internalStorage' | 'paperTape' | 'manualOperation' | 'delay' | 'storedData' | 'display' | 'merge' | 'connector' | 'or' | 'summingJunction' | 'verticalContainer' | 'horizontalContainer' | 'cardWithImageOnLeft' | 'cardWithImageOnTop' | 'cardWithImageOnRight'> | Array<string>,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        title?: string
      }> | Array<'general' | 'flowchart' | 'orgChart' | 'containers' | 'custom'>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shapeIconsPerRow?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      showSearch?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visibility?: 'auto' | 'visible' | 'collapsed' | 'disabled',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    units?: 'in' | 'cm' | 'px';
    /**
     */
    viewUnits?: 'in' | 'cm' | 'px';
    /**
     */
    zoomLevel?: number | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      items?: Array<number>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      value?: number
    };
}
/**
 */
export default class dxDiagram extends Widget {
    constructor(element: TElement, options?: dxDiagramOptions)
    /**
     */
    getNodeDataSource(): DataSource;
    /**
     */
    getEdgeDataSource(): DataSource;
    /**
     */
    getItemByKey(key: Object): dxDiagramItem;
    /**
     */
    getItemById(id: string): dxDiagramItem;
    /**
     */
    export(): string;
    /**
     */
    exportTo(format: 'svg' | 'png' | 'jpg', callback: Function): void;
    /**
     */
    import(data: string, updateExistingItemsOnly?: boolean): void;
    /**
     */
    updateToolbox(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramConnector extends dxDiagramItem {
    /**
     */
    fromKey?: any;
    /**
     */
    fromId?: string;
    /**
     */
    fromPointIndex?: number;
    /**
     */
    points?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
    }>;

    /**
     */
    texts?: Array<string>;
    /**
     */
    toKey?: any;
    /**
     */
    toId?: string;
    /**
     */
    toPointIndex?: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramItem {
    /**
     */
    dataItem?: any;
    /**
     */
    id?: string;
    /**
     */
    key?: Object;
    /**
     */
    itemType?: 'shape' | 'connector';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramShape extends dxDiagramItem {
    /**
     */
    text?: string;
    /**
     */
    type?: 'text' | 'rectangle' | 'ellipse' | 'cross' | 'triangle' | 'diamond' | 'heart' | 'pentagon' | 'hexagon' | 'octagon' | 'star' | 'arrowLeft' | 'arrowTop' | 'arrowRight' | 'arrowBottom' | 'arrowNorthSouth' | 'arrowEastWest' | 'process' | 'decision' | 'terminator' | 'predefinedProcess' | 'document' | 'multipleDocuments' | 'manualInput' | 'preparation' | 'data' | 'database' | 'hardDisk' | 'internalStorage' | 'paperTape' | 'manualOperation' | 'delay' | 'storedData' | 'display' | 'merge' | 'connector' | 'or' | 'summingJunction' | 'verticalContainer' | 'horizontalContainer' | 'cardWithImageOnLeft' | 'cardWithImageOnTop' | 'cardWithImageOnRight' | string;
    /**
     */
    position?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
    };

    /**
     */
    size?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      height?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    attachedConnectorIds?: Array<String>;
    /**
     * Gets the identifier of the container that stores the shape.
     */
    containerId?: string;
    /**
     * Gets identifiers of shapes stored in the container.
     */
    containerChildItemIds?: Array<String>;
    /**
     * Gets whether the container is expanded.
     */
    containerExpanded?: boolean;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramCustomCommand {
    /**
     */
    name?: string;
    /**
     */
    text?: string;
    /**
     */
    icon?: string;
    /**
     */
    items?: Array<dxDiagramCustomCommand>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramAddShapeArgs {
    /**
     */
    shape?: dxDiagramShape;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    position?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
    };
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramAddShapeFromToolboxArgs {
  /**
   */
  shapeType?: 'text' | 'rectangle' | 'ellipse' | 'cross' | 'triangle' | 'diamond' | 'heart' | 'pentagon' | 'hexagon' | 'octagon' | 'star' | 'arrowLeft' | 'arrowTop' | 'arrowRight' | 'arrowBottom' | 'arrowNorthSouth' | 'arrowEastWest' | 'process' | 'decision' | 'terminator' | 'predefinedProcess' | 'document' | 'multipleDocuments' | 'manualInput' | 'preparation' | 'data' | 'database' | 'hardDisk' | 'internalStorage' | 'paperTape' | 'manualOperation' | 'delay' | 'storedData' | 'display' | 'merge' | 'connector' | 'or' | 'summingJunction' | 'verticalContainer' | 'horizontalContainer' | 'cardWithImageOnLeft' | 'cardWithImageOnTop' | 'cardWithImageOnRight' | string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramDeleteShapeArgs {
  /**
   */
  shape?: dxDiagramShape;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramDeleteConnectorArgs {
  /**
   */
  connector?: dxDiagramConnector;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramChangeConnectionArgs {
  /**
   */
  newShape?: dxDiagramShape;
  /**
   */
  oldShape?: dxDiagramShape;
  /**
   */
  connector?: dxDiagramConnector;
  /**
   */
  connectionPointIndex?: number;
  /**
   */
  connectorPosition?: 'start' | 'end';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramChangeConnectorPointsArgs {
  /**
   */
  connector?: dxDiagramConnector;
  /**
   * Warning! This type is used for internal purposes. Do not import it directly.
   */
  newPoints?: Array<{
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    x?: number,
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    y?: number
  }>;
  /**
   * Warning! This type is used for internal purposes. Do not import it directly.
   */
  oldPoints?: Array<{
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    x?: number,
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    y?: number
  }>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramBeforeChangeShapeTextArgs {
  /**
   */
  shape?: dxDiagramShape;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramChangeShapeTextArgs {
  /**
   */
  shape?: dxDiagramShape;
  /**
   */
  text?: string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramBeforeChangeConnectorTextArgs {
  /**
   */
  connector?: dxDiagramConnector;
  /**
   */
  index?: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramChangeConnectorTextArgs {
  /**
   */
  connector?: dxDiagramConnector;
  /**
   */
  index?: number;
  /**
   */
  text?: string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramResizeShapeArgs {
  /**
   */
  shape?: dxDiagramShape;
  /**
   * Warning! This type is used for internal purposes. Do not import it directly.
   */
  newSize?: {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    height?: number,
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    width?: number
  };
  /**
   * Warning! This type is used for internal purposes. Do not import it directly.
   */
  oldSize?: {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    height?: number,
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    width?: number
  };
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDiagramMoveShapeArgs {
  /**
   */
  shape?: dxDiagramShape;
  /**
   * Warning! This type is used for internal purposes. Do not import it directly.
   */
   newPosition?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
   };
  /**
   * Warning! This type is used for internal purposes. Do not import it directly.
   */
   oldPosition?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      x?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      y?: number
   };
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDiagramOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDiagramOptions;
