/**
* DevExtreme (ui/drawer.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import {
    template
} from '../core/templates/template';

import {
    TEvent
} from '../events/index';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDrawerOptions extends WidgetOptions<dxDrawer> {
    /**
     */
    animationDuration?: number;
    /**
     */
    animationEnabled?: boolean;
    /**
     */
    closeOnOutsideClick?: boolean | ((event: TEvent) => boolean);
    /**
     */
    maxSize?: number;
    /**
     */
    minSize?: number;
    /**
     */
    opened?: boolean;
    /**
     */
    openedStateMode?: 'overlap' | 'shrink' | 'push';
    /**
     */
    position?: 'left' | 'right' | 'top' | 'bottom' | 'before' | 'after';
    /**
     */
    revealMode?: 'slide' | 'expand';
    /**
     */
    shading?: boolean;
    /**
     * @deprecated
     */
    target?: string | TElement;
    /**
     */
    template?: template | ((Element: TElement) => any);
}
/**
 */
export default class dxDrawer extends Widget {
    constructor(element: TElement, options?: dxDrawerOptions)
    /**
     */
    content(): TElement;
    /**
     */
    hide(): TPromise<void>;
    /**
     */
    show(): TPromise<void>;
    /**
     */
    toggle(): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDrawerOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDrawerOptions;
