/**
* DevExtreme (ui/drop_down_button.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import {
    template
} from '../core/templates/template';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    TEvent
} from '../events/index';

import {
    dxListItem
} from './list';

import {
    dxPopupOptions
} from './popup';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDropDownButtonOptions extends WidgetOptions<dxDropDownButton> {
    /**
     */
    dataSource?: string | Array<dxDropDownButtonItem | any> | DataSource | DataSourceOptions;
    /**
     */
    deferRendering?: boolean;
    /**
     */
    displayExpr?: string | ((itemData: any) => string);
    /**
     */
    dropDownContentTemplate?: template | ((data: Array<string | number | any> | DataSource, contentElement: TElement) => string | TElement);
    /**
     */
    dropDownOptions?: dxPopupOptions;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    icon?: string;
    /**
     */
    itemTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    items?: Array<dxDropDownButtonItem | any>;
    /**
     */
    keyExpr?: string;
    /**
     */
    noDataText?: string;
    /**
     */
    onButtonClick?: ((e: { component?: dxDropDownButton, element?: TElement, model?: any, event?: TEvent, selectedItem?: any }) => void) | string;
    /**
     */
    onItemClick?: ((e: { component?: dxDropDownButton, element?: TElement, model?: any, event?: TEvent, itemData?: any, itemElement?: TElement }) => void) | string;
    /**
     */
    onSelectionChanged?: ((e: { component?: dxDropDownButton, element?: TElement, model?: any, item?: any, previousItem?: any }) => void) | string;
    /**
     */
    opened?: boolean;
    /**
     */
    selectedItem?: string | number | any;
    /**
     */
    selectedItemKey?: string | number;
    /**
     */
    showArrowIcon?: boolean;
    /**
     */
    splitButton?: boolean;
    /**
     */
    stylingMode?: 'text' | 'outlined' | 'contained';
    /**
     */
    text?: string;
    /**
     */
    useSelectMode?: boolean;
    /**
     */
    wrapItemText?: boolean;
    /**
     */
    useItemTextAsTitle?: boolean;
}
/**
 */
export default class dxDropDownButton extends Widget {
    constructor(element: TElement, options?: dxDropDownButtonOptions)
    /**
     */
    close(): TPromise<void>;
    getDataSource(): DataSource;
    /**
     */
    open(): TPromise<void>;
    /**
     */
    toggle(): TPromise<void>;
    /**
     */
    toggle(visibility: boolean): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDropDownButtonItem extends dxListItem {
    /**
     */
    onClick?: ((e: { component?: dxDropDownButton, element?: TElement, model?: any, event?: TEvent }) => void) | string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDropDownButtonOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDropDownButtonOptions;
