/**
* DevExtreme (ui/drop_down_editor/ui.drop_down_list.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../../core/element';

import {
    template
} from '../../core/templates/template';

import DataSource from '../../data/data_source';

import {
    TEvent
} from '../../events/index';

import {
    DataExpressionMixinOptions
} from '../editor/ui.data_expression';

import dxDropDownEditor, {
    dxDropDownEditorOptions
} from './ui.drop_down_editor';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDropDownListOptions<T = dxDropDownList> extends DataExpressionMixinOptions<T>, dxDropDownEditorOptions<T> {
    /**
     */
    displayValue?: string;
    /**
     */
    groupTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    grouped?: boolean;
    /**
     */
    minSearchLength?: number;
    /**
     */
    noDataText?: string;
    /**
     */
    onItemClick?: ((e: { component?: T, element?: TElement, model?: any, itemData?: any, itemElement?: any, itemIndex?: number | any, event?: TEvent }) => void);
    /**
     */
    onSelectionChanged?: ((e: { component?: T, element?: TElement, model?: any, selectedItem?: any }) => void);
    /**
     */
    onValueChanged?: ((e: { component?: T, element?: TElement, model?: any, value?: any, previousValue?: any, event?: TEvent }) => void);
    /**
     */
    searchEnabled?: boolean;
    /**
     */
    searchExpr?: string | Function | Array<string | Function>;
    /**
     */
    searchMode?: 'contains' | 'startswith';
    /**
     */
    searchTimeout?: number;
    /**
     */
    selectedItem?: any;
    /**
     */
    showDataBeforeSearch?: boolean;
    /**
     */
    value?: any;
    /**
     */
    valueChangeEvent?: string;
    /**
     */
    wrapItemText?: boolean;
    /**
     */
    useItemTextAsTitle?: boolean;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class dxDropDownList extends dxDropDownEditor {
    constructor(element: TElement, options?: dxDropDownListOptions)
    getDataSource(): DataSource;
}
