/**
* DevExtreme (ui/editor/editor.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../../core/element';

import {
    TEvent
} from '../../events/index';

import Widget, {
    WidgetOptions
} from '../widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface EditorOptions<T = Editor> extends WidgetOptions<T> {
    /**
     */
    isValid?: boolean;
    /**
     */
    onValueChanged?: ((e: { component?: T, element?: TElement, model?: any, value?: any, previousValue?: any, event?: TEvent }) => void);
    /**
     */
    readOnly?: boolean;
    /**
     */
    validationError?: any;
    /**
     */
    validationErrors?: Array<any>;
    /**
     */
    validationMessageMode?: 'always' | 'auto';
    /**
     */
    validationStatus?: 'valid' | 'invalid' | 'pending';
    /**
     */
    value?: any;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    stylingMode?: 'outlined' | 'underlined' | 'filled';
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class Editor extends Widget {
    constructor(element: TElement, options?: EditorOptions)
    /**
     */
    reset(): void;
}
