/**
* DevExtreme (ui/gantt.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TEvent
} from '../events/index';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    dxTreeListColumn
} from './tree_list';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

import {
    dxToolbarItem
} from './toolbar';

import {
    dxContextMenuItem
} from './context_menu';

import {
    template
} from '../core/templates/template';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGanttOptions extends WidgetOptions<dxGantt> {
    /**
     */
    allowSelection?: boolean;
    /**
     */
    columns?: Array<dxTreeListColumn | string>;
    /**
     */
    dependencies?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataSource?: Array<any> | DataSource | DataSourceOptions,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keyExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      predecessorIdExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      successorIdExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      typeExpr?: string | Function
    };
    /**
     */
    editing?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowDependencyAdding?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowDependencyDeleting?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowResourceAdding?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowResourceDeleting?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowResourceUpdating?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowTaskAdding?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowTaskDeleting?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowTaskResourceUpdating?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowTaskUpdating?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      enabled?: boolean
    };
    /**
     */
    validation?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      validateDependencies?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      autoUpdateParentTasks?: boolean
    };
    /**
     */
    onSelectionChanged?: ((e: { component?: dxGantt, element?: TElement, model?: any, selectedRowKey?: any }) => void);
    /**
     */
    onCustomCommand?: ((e: { component?: dxGantt, element?: TElement, name?: string }) => void);
        /**
         */
    onContextMenuPreparing?: ((e: { component?: dxGantt, element?: TElement, cancel?: boolean, event?: TEvent, targetKey?: any, targetType?: string, data?: any, items?: Array<any> }) => void);
    /**
     */
    onTaskInserting?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any }) => void);
    /**
     */
    onTaskInserted?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onTaskDeleting?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any, key?: any }) => void);
    /**
     */
    onTaskDeleted?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onTaskUpdating?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, newValues?: any, values?: any, key?: any }) => void);
    /**
     */
    onTaskUpdated?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onTaskMoving?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, newValues?: any, values?: any, key?: any }) => void);
    /**
     */
    onTaskEditDialogShowing?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any, key?: any, readOnlyFields?: Array<string>, hiddenFields?: Array<string> }) => void);
    /**
     */
    onDependencyInserting?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any }) => void);
    /**
     */
    onDependencyInserted?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onDependencyDeleting?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any, key?: any }) => void);
    /**
     */
    onDependencyDeleted?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onResourceInserting?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any }) => void);
    /**
     */
    onResourceInserted?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onResourceDeleting?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any, key?: any }) => void);
     /**
      */
    onResourceDeleted?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onResourceAssigning?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any }) => void);
     /**
      */
    onResourceAssigned?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onResourceUnassigning?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, values?: any, key?: any }) => void);
     /**
      */
    onResourceUnassigned?: ((e: { component?: dxGantt, element?: TElement, model?: any, values?: any, key?: any }) => void);
    /**
     */
    onTaskClick?: ((e: { component?: dxGantt, element?: TElement, model?: any, event?: TEvent, key?: any, data?: any }) => void);
    /**
     */
    onTaskDblClick?: ((e: { component?: dxGantt, element?: TElement, model?: any, cancel?: boolean, event?: TEvent, key?: any, data?: any }) => void);
    /**
     */
    resourceAssignments?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataSource?: Array<any> | DataSource | DataSourceOptions,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keyExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      resourceIdExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      taskIdExpr?: string | Function
    };
    /**
     */
    resources?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      colorExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataSource?: Array<any> | DataSource | DataSourceOptions,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keyExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      textExpr?: string | Function
    };
    /**
     */
    scaleType?: 'auto' | 'minutes' | 'hours' | 'days' | 'weeks' | 'months' | 'quarters' | 'years';
    /**
     */
    selectedRowKey?: any;
    /**
     */
    showResources?: boolean;
    /**
     */
    showRowLines?: boolean;
    /**
     */
    taskListWidth?: number;
    /**
     */
    taskTitlePosition?: 'inside' | 'outside' | 'none';
    /**
     */
    firstDayOfWeek?: 0 | 1 | 2 | 3 | 4 | 5 | 6;
    /**
     */
    tasks?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      colorExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataSource?: Array<any> | DataSource | DataSourceOptions,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      endExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keyExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      parentIdExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      progressExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      startExpr?: string | Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      titleExpr?: string | Function
    };
    /**
     */
    toolbar?: dxGanttToolbar;
    /**
     */
    contextMenu?: dxGanttContextMenu;
    /**
     */
    stripLines?: Array<dxGanttStripLine>;
    /**
     */
    taskTooltipContentTemplate?: template | ((container: TElement, task: any) => string | TElement);
    /**
     */
    taskContentTemplate?: template | ((container: TElement, item: {cellSize: any, isMilestone: boolean, taskData: any, taskHTML: any, taskPosition: any, taskResources:  Array<any>, taskSize: any }) => string | TElement);
    /**
     */
    rootValue?: any;
}
/**
 */
export default class dxGantt extends Widget {
    constructor(element: TElement, options?: dxGanttOptions)
    /**
     */
    getTaskData(key: any): any;
    /**
     */
    getDependencyData(key: any): any;
    /**
     */
    getResourceData(key: any): any;
    /**
     */
    getResourceAssignmentData(key: any): any;
    /**
     */
    insertTask(data: any): void;
    /**
     */
    deleteTask(key: any): void;
    /**
     */
    updateTask(key: any, data: any): void;
    /**
     */
    insertDependency(data: any): void;
    /**
     */
    deleteDependency(key: any): void;
    /**
     */
    insertResource(data: any,  taskKeys?: Array<any>): void;
    /**
     */
    deleteResource(key: any): void;
    /**
     */
    assignResourceToTask(resourceKey: any, taskKey: any): void;
    /**
     */
    unassignResourceFromTask(resourceKey: any, taskKey: any): void;
    /**
     */
    getTaskResources(key: any): Array<any>;
    /**
     */
    getVisibleTaskKeys(): Array<any>;
    /**
     */
    getVisibleDependencyKeys(): Array<any>;
    /**
     */
    getVisibleResourceKeys(): Array<any>;
    /**
     */
    getVisibleResourceAssignmentKeys(): Array<any>;
    /**
     */
    updateDimensions(): void;
    /**
     */
    scrollToDate(date: Date | Number | string): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGanttToolbar {
    /**
     */
    items?: Array<dxGanttToolbarItem | 'separator' | 'undo' | 'redo' | 'expandAll' | 'collapseAll' | 'addTask' | 'deleteTask' | 'zoomIn' | 'zoomOut'>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGanttContextMenu {
    /**
     */
    enabled?: boolean
    /**
     */
    items?: Array<dxGanttContextMenuItem | 'undo' | 'redo' | 'expandAll' | 'collapseAll' | 'addTask' | 'deleteTask' | 'zoomIn' | 'zoomOut' | 'deleteDependency' | 'taskDetails'>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGanttToolbarItem extends dxToolbarItem {
    /**
     */
    name?: 'separator' | 'undo' | 'redo' | 'expandAll' | 'collapseAll' | 'addTask' | 'deleteTask' | 'zoomIn' | 'zoomOut' | string;
    /**
     */
    location?: 'after' | 'before' | 'center';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGanttContextMenuItem extends dxContextMenuItem {
    /**
     */
    name?: 'undo' | 'redo' | 'expandAll' | 'collapseAll' | 'addTask' | 'deleteTask' | 'zoomIn' | 'zoomOut' | 'deleteDependency' | 'taskDetails' | string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGanttStripLine {
    /**
     */
    cssClass?: string;
    /**
     */
    end?: Date | number | string | (() => Date | number | string);
    /**
     */
    start?: Date | number | string | (() => Date | number | string);
    /**
     */
    title?: string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxGanttOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxGanttOptions;
