/**
* DevExtreme (ui/hierarchical_collection/ui.hierarchical_collection_widget.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../../core/element';

import CollectionWidget, {
    CollectionWidgetOptions
} from '../collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface HierarchicalCollectionWidgetOptions<T = HierarchicalCollectionWidget> extends CollectionWidgetOptions<T> {
    /**
     */
    disabledExpr?: string | Function;
    /**
     */
    displayExpr?: string | ((item: any) => string);
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    itemsExpr?: string | Function;
    /**
     */
    keyExpr?: string | Function;
    /**
     */
    selectedExpr?: string | Function;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class HierarchicalCollectionWidget extends CollectionWidget {
    constructor(element: TElement, options?: HierarchicalCollectionWidgetOptions)
}
