/**
* DevExtreme (ui/load_panel.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    animationConfig
} from '../animation/fx';

import {
    positionConfig
} from '../animation/position';

import dxOverlay, {
    dxOverlayAnimation,
    dxOverlayOptions
} from './overlay';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLoadPanelOptions extends dxOverlayOptions<dxLoadPanel> {
    /**
     */
    animation?: dxLoadPanelAnimation;
    /**
     */
    container?: string | TElement;
    /**
     */
    delay?: number;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    indicatorSrc?: string;
    /**
     */
    maxHeight?: number | string | (() => number | string);
    /**
     */
    maxWidth?: number | string | (() => number | string);
    /**
     */
    message?: string;
    /**
     */
    position?: 'bottom' | 'center' | 'left' | 'left bottom' | 'left top' | 'right' | 'right bottom' | 'right top' | 'top' | positionConfig | Function;
    /**
     */
    shadingColor?: string;
    /**
     */
    showIndicator?: boolean;
    /**
     */
    showPane?: boolean;
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLoadPanelAnimation extends dxOverlayAnimation {
    /**
     * 
     */
    hide?: animationConfig;
    /**
     * 
     */
    show?: animationConfig;
}
/**
 */
export default class dxLoadPanel extends dxOverlay {
    constructor(element: TElement, options?: dxLoadPanelOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxLoadPanelOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxLoadPanelOptions;
