/**
* DevExtreme (ui/lookup.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    animationConfig
} from '../animation/fx';

import {
    positionConfig
} from '../animation/position';

import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    TEvent
} from '../events/index';

import dxDropDownList, {
    dxDropDownListOptions
} from './drop_down_editor/ui.drop_down_list';

import {
    dxPopoverOptions
} from './popover';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLookupOptions extends dxDropDownListOptions<dxLookup> {
    /**
     * @deprecated
     */
    animation?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hide?: animationConfig,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      show?: animationConfig
    };
    /**
     */
    applyButtonText?: string;
    /**
     */
    applyValueMode?: 'instantly' | 'useButtons';
    /**
     */
    cancelButtonText?: string;
    /**
     */
    cleanSearchOnOpening?: boolean;
    /**
     */
    clearButtonText?: string;
    /**
     * @deprecated
     */
    closeOnOutsideClick?: boolean | ((event: TEvent) => boolean);
    /**
     */
    fieldTemplate?: template | ((selectedItem: any, fieldElement: TElement) => string | TElement);
    /**
     */
    focusStateEnabled?: boolean;
    /**
     * @deprecated
     */
    fullScreen?: boolean;
    /**
     */
    groupTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    grouped?: boolean;
    /**
     */
    nextButtonText?: string;
    /**
     */
    onPageLoading?: ((e: { component?: dxLookup, element?: TElement, model?: any }) => void);
    /**
     */
    onPullRefresh?: ((e: { component?: dxLookup, element?: TElement, model?: any }) => void);
    /**
     */
    onScroll?: ((e: { component?: dxLookup, element?: TElement, model?: any, event?: TEvent, scrollOffset?: any, reachedLeft?: boolean, reachedRight?: boolean, reachedTop?: boolean, reachedBottom?: boolean }) => void);
    /**
     * @deprecated
     */
    onTitleRendered?: ((e: { component?: dxLookup, element?: TElement, model?: any, titleElement?: TElement }) => void);
    /**
     */
    onValueChanged?: ((e: { component?: dxLookup, element?: TElement, model?: any, value?: any, previousValue?: any, event?: TEvent }) => void);
    /**
     */
    pageLoadMode?: 'nextButton' | 'scrollBottom';
    /**
     */
    pageLoadingText?: string;
    /**
     */
    placeholder?: string;
    /**
     * @deprecated
     */
    popupHeight?: number | string | (() => number | string);
    /**
     * @deprecated
     */
    popupWidth?: number | string | (() => number | string);
    /**
     * @deprecated
     */
    position?: positionConfig;
    /**
     */
    pullRefreshEnabled?: boolean;
    /**
     */
    pulledDownText?: string;
    /**
     */
    pullingDownText?: string;
    /**
     */
    refreshingText?: string;
    /**
     */
    searchEnabled?: boolean;
    /**
     */
    searchPlaceholder?: string;
    /**
     * @deprecated
     */
    shading?: boolean;
    /**
     */
    showCancelButton?: boolean;
    /**
     */
    showClearButton?: boolean;
    /**
     * @deprecated
     */
    showPopupTitle?: boolean;
    /**
     * @deprecated
     */
    title?: string;
    /**
     * @deprecated
     */
    titleTemplate?: template | ((titleElement: TElement) => string | TElement);
    /**
     */
    useNativeScrolling?: boolean;
    /**
     */
    usePopover?: boolean;
    /**
     */
    dropDownCentered?: boolean;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    dropDownOptions?: dxPopoverOptions;

}
/**
 */
export default class dxLookup extends dxDropDownList {
    constructor(element: TElement, options?: dxLookupOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxLookupOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxLookupOptions;
