/**
* DevExtreme (ui/map.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import {
    TEvent
} from '../events/index';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface MapLocation {
    /**
     */
    lat?: number;
    /**
     */
    lng?: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxMapOptions extends WidgetOptions<dxMap> {
    /**
     */
    apiKey?: string | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      bing?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      google?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      googleStatic?: string
    };
    /**
     */
    autoAdjust?: boolean;
    /**
     */
    center?: any | string | Array<number>;
    /**
     */
    controls?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     * @deprecated
     */
    key?: string | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      bing?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      google?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      googleStatic?: string
    };
    /**
     */
    markerIconSrc?: string;
    /**
     */
    markers?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      iconSrc?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      location?: any | string | Array<number>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      onClick?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      tooltip?: string | {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        isShown?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        text?: string
      }
    }>;
    /**
     */
    onClick?: ((e: { component?: dxMap, element?: TElement, model?: any, location?: any, event?: TEvent }) => void) | string;
    /**
     */
    onMarkerAdded?: ((e: { component?: dxMap, element?: TElement, model?: any, options?: any, originalMarker?: any }) => void);
    /**
     */
    onMarkerRemoved?: ((e: { component?: dxMap, element?: TElement, model?: any, options?: any }) => void);
    /**
     */
    onReady?: ((e: { component?: dxMap, element?: TElement, model?: any, originalMap?: any }) => void);
    /**
     */
    onRouteAdded?: ((e: { component?: dxMap, element?: TElement, model?: any, options?: any, originalRoute?: any }) => void);
    /**
     */
    onRouteRemoved?: ((e: { component?: dxMap, element?: TElement, model?: any, options?: any }) => void);
    /**
     */
    provider?: 'bing' | 'google' | 'googleStatic';
    /**
     */
    routes?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      color?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      locations?: Array<any>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      mode?: 'driving' | 'walking',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      opacity?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      weight?: number
    }>;
    /**
     */
    type?: 'hybrid' | 'roadmap' | 'satellite';
    /**
     */
    width?: number | string | (() => number | string);
    /**
     */
    zoom?: number;
}
/**
 */
export default class dxMap extends Widget {
    constructor(element: TElement, options?: dxMapOptions)
    /**
     */
    addMarker(markerOptions: any | Array<any>): TPromise<any>;
    /**
     */
    addRoute(options: any | Array<any>): TPromise<any>;
    /**
     */
    removeMarker(marker: any | number | Array<any>): TPromise<void>;
    /**
     */
    removeRoute(route: any | number | Array<any>): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxMapOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxMapOptions;
