/**
* DevExtreme (ui/multi_view.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxMultiViewOptions<T = dxMultiView> extends CollectionWidgetOptions<T> {
    /**
     */
    animationEnabled?: boolean;
    /**
     */
    dataSource?: string | Array<string | dxMultiViewItem | any> | DataSource | DataSourceOptions;
    /**
     */
    deferRendering?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    items?: Array<string | dxMultiViewItem | any>;
    /**
     */
    loop?: boolean;
    /**
     */
    selectedIndex?: number;
    /**
     */
    swipeEnabled?: boolean;
}
/**
 */
export default class dxMultiView extends CollectionWidget {
    constructor(element: TElement, options?: dxMultiViewOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxMultiViewItem extends CollectionWidgetItem {
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxMultiViewOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxMultiViewOptions;
