/**
* DevExtreme (ui/number_box.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import dxTextEditor, {
    dxTextEditorButton,
    dxTextEditorOptions
} from './text_box/ui.text_editor.base';

import {
    format
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxNumberBoxOptions extends dxTextEditorOptions<dxNumberBox> {
    /**
     */
    buttons?: Array<'clear' | 'spins' | dxTextEditorButton>;
    /**
     */
    format?: format;
    /**
     */
    invalidValueMessage?: string;
    /**
     */
    max?: number;
    /**
     */
    min?: number;
    /**
     */
    mode?: 'number' | 'text' | 'tel';
    /**
     */
    showSpinButtons?: boolean;
    /**
     */
    step?: number;
    /**
     */
    useLargeSpinButtons?: boolean;
    /**
     */
    value?: number;
}
/**
 */
export default class dxNumberBox extends dxTextEditor {
    constructor(element: TElement, options?: dxNumberBoxOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxNumberBoxOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxNumberBoxOptions;
