/**
* DevExtreme (ui/pivot_grid_field_chooser.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TEvent
} from '../events/index';

import PivotGridDataSource, {
    PivotGridDataSourceField
} from './pivot_grid/data_source';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxPivotGridFieldChooserOptions extends WidgetOptions<dxPivotGridFieldChooser> {
    /**
     */
    allowSearch?: boolean;
    /**
     */
    applyChangesMode?: 'instantly' | 'onDemand';
    /**
     */
    dataSource?: PivotGridDataSource;
    /**
     */
    headerFilter?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allowSearch?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      height?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      searchTimeout?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      showRelevantValues?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      texts?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        cancel?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        emptyValue?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        ok?: string
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    layout?: 0 | 1 | 2;
    /**
     */
    onContextMenuPreparing?: ((e: { component?: dxPivotGridFieldChooser, element?: TElement, model?: any, items?: Array<any>, area?: string, field?: PivotGridDataSourceField, event?: TEvent }) => void);
    /**
     */
    searchTimeout?: number;
    /**
     */
    state?: any;
    /**
     */
    texts?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      allFields?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      columnFields?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      dataFields?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      filterFields?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      rowFields?: string
    };
}
/**
 */
export default class dxPivotGridFieldChooser extends Widget {
    constructor(element: TElement, options?: dxPivotGridFieldChooserOptions)
    /**
     */
    applyChanges(): void;
    /**
     */
    cancelChanges(): void;
    /**
     */
    getDataSource(): PivotGridDataSource;
    /**
     */
    updateDimensions(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxPivotGridFieldChooserOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxPivotGridFieldChooserOptions;
