/**
* DevExtreme (ui/popover.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    animationConfig
} from '../animation/fx';

import {
    positionConfig
} from '../animation/position';

import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import {
    TEvent
} from '../events/index';

import dxPopup, {
    dxPopupAnimation,
    dxPopupOptions
} from './popup';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxPopoverOptions<T = dxPopover> extends dxPopupOptions<T> {
    /**
     */
    animation?: dxPopoverAnimation;
    /**
     */
    closeOnOutsideClick?: boolean | ((event: TEvent) => boolean);
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    hideEvent?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      delay?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      name?: string
    } | string;
    /**
     */
    position?: 'bottom' | 'left' | 'right' | 'top' | positionConfig;
    /**
     */
    shading?: boolean;
    /**
     */
    showEvent?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      delay?: number,
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
      name?: string
    } | string;
    /**
     */
    showTitle?: boolean;
    /**
     */
    target?: string | TElement;
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxPopoverAnimation extends dxPopupAnimation {
    /**
     * An object that defines the animation properties used when the UI component is being hidden.
     */
    hide?: animationConfig;
    /**
     * An object that defines the animation properties used when the UI component is being shown.
     */
    show?: animationConfig;
}
/**
 */
export default class dxPopover extends dxPopup {
    constructor(element: TElement, options?: dxPopoverOptions)
    show(): TPromise<boolean>;
    /**
     */
    show(target: string | TElement): TPromise<boolean>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxPopoverOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxPopoverOptions;
