/**
* DevExtreme (ui/progress_bar.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TEvent
} from '../events/index';

import dxTrackBar, {
    dxTrackBarOptions
} from './track_bar';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxProgressBarOptions extends dxTrackBarOptions<dxProgressBar> {
    /**
     */
    onComplete?: ((e: { component?: dxProgressBar, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    showStatus?: boolean;
    /**
     */
    statusFormat?: string | ((ratio: number, value: number) => string);
    /**
     */
    value?: number;
}
/**
 */
export default class dxProgressBar extends dxTrackBar {
    constructor(element: TElement, options?: dxProgressBarOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxProgressBarOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxProgressBarOptions;
