/**
* DevExtreme (ui/radio_group.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import DataSource from '../data/data_source';

import Editor, {
    EditorOptions
} from './editor/editor';

import {
    DataExpressionMixinOptions
} from './editor/ui.data_expression';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxRadioGroupOptions extends EditorOptions<dxRadioGroup>, DataExpressionMixinOptions<dxRadioGroup> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    layout?: 'horizontal' | 'vertical';
    /**
     */
    name?: string;
    /**
     */
    value?: any;
}
/**
 */
export default class dxRadioGroup extends Editor {
    constructor(element: TElement, options?: dxRadioGroupOptions)
    getDataSource(): DataSource;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxRadioGroupOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxRadioGroupOptions;
