/**
* DevExtreme (ui/range_slider.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    dxSliderBaseOptions
} from './slider';

import dxTrackBar from './track_bar';
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxRangeSliderOptions extends dxSliderBaseOptions<dxRangeSlider> {
    /**
     */
    end?: number;
    /**
     */
    endName?: string;
    /**
     */
    onValueChanged?: ((e: { component?: dxRangeSlider, element?: TElement, model?: any, start?: number, end?: number, value?: Array<number> }) => void);
    /**
     */
    start?: number;
    /**
     */
    startName?: string;
    /**
     */
    value?: Array<number>;
}
/**
 */
export default class dxRangeSlider extends dxTrackBar {
    constructor(element: TElement, options?: dxRangeSliderOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxRangeSliderOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxRangeSliderOptions;
