/**
* DevExtreme (ui/resizable.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import DOMComponent, {
    DOMComponentOptions
} from '../core/dom_component';

import {
    TElement
} from '../core/element';

import {
    TEvent
} from '../events/index';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxResizableOptions extends DOMComponentOptions<dxResizable> {
    /**
     */
    handles?: 'bottom' | 'left' | 'right' | 'top' | 'all' | string;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    maxHeight?: number;
    /**
     */
    maxWidth?: number;
    /**
     */
    minHeight?: number;
    /**
     */
    minWidth?: number;
    /**
     */
    onResize?: ((e: { component?: dxResizable, element?: TElement, model?: any, event?: TEvent, width?: number, height?: number }) => void);
    /**
     */
    onResizeEnd?: ((e: { component?: dxResizable, element?: TElement, model?: any, event?: TEvent, width?: number, height?: number }) => void);
    /**
     */
    onResizeStart?: ((e: { component?: dxResizable, element?: TElement, model?: any, event?: TEvent, width?: number, height?: number }) => void);
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 */
export default class dxResizable extends DOMComponent {
    constructor(element: TElement, options?: dxResizableOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxResizableOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxResizableOptions;
