/**
* DevExtreme (ui/scroll_view.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import dxScrollable, {
    dxScrollableOptions
} from './scroll_view/ui.scrollable';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxScrollViewOptions extends dxScrollableOptions<dxScrollView> {
    /**
     */
    onPullDown?: ((e: { component?: dxScrollView, element?: TElement, model?: any }) => void);
    /**
     */
    onReachBottom?: ((e: { component?: dxScrollView, element?: TElement, model?: any }) => void);
    /**
     */
    pulledDownText?: string;
    /**
     */
    pullingDownText?: string;
    /**
     */
    reachBottomText?: string;
    /**
     */
    refreshingText?: string;
}
/**
 */
export default class dxScrollView extends dxScrollable {
    constructor(element: TElement, options?: dxScrollViewOptions)
    /**
     */
    refresh(): void;
    /**
     */
    release(preventScrollBottom: boolean): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxScrollViewOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxScrollViewOptions;
