/**
* DevExtreme (ui/scroll_view/ui.scrollable.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import DOMComponent, {
    DOMComponentOptions
} from '../../core/dom_component';

import {
    TElement
} from '../../core/element';

import {
    TPromise
} from '../../core/utils/deferred';

import {
    TEvent
} from '../../events/index';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxScrollableOptions<T = dxScrollable> extends DOMComponentOptions<T> {
    /**
     */
    bounceEnabled?: boolean;
    /**
     */
    direction?: 'both' | 'horizontal' | 'vertical';
    /**
     */
    disabled?: boolean;
    /**
     */
    onScroll?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent, scrollOffset?: any, reachedLeft?: boolean, reachedRight?: boolean, reachedTop?: boolean, reachedBottom?: boolean }) => void);
    /**
     */
    onUpdated?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent, scrollOffset?: any, reachedLeft?: boolean, reachedRight?: boolean, reachedTop?: boolean, reachedBottom?: boolean }) => void);
    /**
     */
    scrollByContent?: boolean;
    /**
     */
    scrollByThumb?: boolean;
    /**
     */
    showScrollbar?: 'onScroll' | 'onHover' | 'always' | 'never';
    /**
     */
    useNative?: boolean;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class dxScrollable extends DOMComponent {
    constructor(element: TElement, options?: dxScrollableOptions)
    /**
     */
    clientHeight(): number;
    /**
     */
    clientWidth(): number;
    /**
     */
    content(): TElement;
    /**
     */
    scrollBy(distance: number | any): void;
    /**
     */
    scrollHeight(): number;
    /**
     */
    scrollLeft(): number;
    /**
     */
    scrollOffset(): any;
    /**
     */
    scrollTo(targetLocation: number | any): void;
    /**
     */
    scrollToElement(element: TElement): void;
    /**
     */
    scrollTop(): number;
    /**
     */
    scrollWidth(): number;
    /**
     */
    update(): TPromise<void>;
}
