/**
* DevExtreme (ui/slide_out.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    TPromise
} from '../core/utils/deferred';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSlideOutOptions extends CollectionWidgetOptions<dxSlideOut> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    contentTemplate?: template | ((container: TElement) => string | TElement);
    /**
     */
    dataSource?: string | Array<string | dxSlideOutItem | any> | DataSource | DataSourceOptions;
    /**
     */
    items?: Array<string | dxSlideOutItem | any>;
    /**
     */
    menuGroupTemplate?: template | ((groupData: any, groupIndex: number, groupElement: any) => string | TElement);
    /**
     */
    menuGrouped?: boolean;
    /**
     */
    menuItemTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    menuPosition?: 'inverted' | 'normal';
    /**
     */
    menuVisible?: boolean;
    /**
     */
    onMenuGroupRendered?: ((e: { component?: dxSlideOut, element?: TElement, model?: any }) => void);
    /**
     */
    onMenuItemRendered?: ((e: { component?: dxSlideOut, element?: TElement, model?: any }) => void);
    /**
     */
    selectedIndex?: number;
    /**
     */
    swipeEnabled?: boolean;
}
/**
 */
export default class dxSlideOut extends CollectionWidget {
    constructor(element: TElement, options?: dxSlideOutOptions)
    /**
     */
    hideMenu(): TPromise<void>;
    /**
     */
    showMenu(): TPromise<void>;
    /**
     */
    toggleMenuVisibility(showing: boolean): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSlideOutItem extends CollectionWidgetItem {
    /**
     */
    menuTemplate?: template | (() => string | TElement);
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxSlideOutOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxSlideOutOptions;
