/**
* DevExtreme (ui/slide_out_view.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    TPromise
} from '../core/utils/deferred';

import {
    template
} from '../core/templates/template';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSlideOutViewOptions extends WidgetOptions<dxSlideOutView> {
    /**
     */
    contentTemplate?: template | ((contentElement: TElement) => any);
    /**
     */
    menuPosition?: 'inverted' | 'normal';
    /**
     */
    menuTemplate?: template | ((menuElement: TElement) => any);
    /**
     */
    menuVisible?: boolean;
    /**
     */
    swipeEnabled?: boolean;
}
/**
 */
export default class dxSlideOutView extends Widget {
    constructor(element: TElement, options?: dxSlideOutViewOptions)
    /**
     */
    content(): TElement;
    /**
     */
    hideMenu(): TPromise<void>;
    /**
     */
    menuContent(): TElement;
    /**
     */
    showMenu(): TPromise<void>;
    /**
     */
    toggleMenuVisibility(): TPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxSlideOutViewOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxSlideOutViewOptions;
