/**
* DevExtreme (ui/slider.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import dxTrackBar, {
    dxTrackBarOptions
} from './track_bar';

import {
    format
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSliderOptions extends dxSliderBaseOptions<dxSlider> {
    /**
     */
    value?: number;
}
/**
 */
export default class dxSlider extends dxTrackBar {
    constructor(element: TElement, options?: dxSliderOptions)
}

/**
 * 
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSliderBaseOptions<T> extends dxTrackBarOptions<T> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    keyStep?: number;
    /**
     */
    label?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      format?: format,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      position?: 'bottom' | 'top',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visible?: boolean
    };
    /**
     */
    name?: string;
    /**
     */
    showRange?: boolean;
    /**
     */
    step?: number;
    /**
     */
    tooltip?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      enabled?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      format?: format,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      position?: 'bottom' | 'top',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      showMode?: 'always' | 'onHover'
    };
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxSliderOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxSliderOptions;
