/**
* DevExtreme (ui/tab_panel.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    TEvent
} from '../events/index';

import dxMultiView, {
    dxMultiViewItem,
    dxMultiViewOptions
} from './multi_view';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTabPanelOptions extends dxMultiViewOptions<dxTabPanel> {
    /**
     */
    animationEnabled?: boolean;
    /**
     */
    dataSource?: string | Array<string | dxTabPanelItem | any> | DataSource | DataSourceOptions;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    itemTitleTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     */
    items?: Array<string | dxTabPanelItem | any>;
    /**
     */
    onTitleClick?: ((e: { component?: dxTabPanel, element?: TElement, model?: any, itemData?: any, itemElement?: TElement, event?: TEvent }) => void) | string;
    /**
     */
    onTitleHold?: ((e: { component?: dxTabPanel, element?: TElement, model?: any, itemData?: any, itemElement?: TElement, event?: TEvent }) => void);
    /**
     */
    onTitleRendered?: ((e: { component?: dxTabPanel, element?: TElement, model?: any, itemData?: any, itemElement?: TElement }) => void);
    /**
     */
    repaintChangesOnly?: boolean;
    /**
     */
    scrollByContent?: boolean;
    /**
     */
    scrollingEnabled?: boolean;
    /**
     */
    showNavButtons?: boolean;
    /**
     */
    swipeEnabled?: boolean;
}
/**
 */
export default class dxTabPanel extends dxMultiView {
    constructor(element: TElement, options?: dxTabPanelOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTabPanelItem extends dxMultiViewItem {
    /**
     */
    badge?: string;
    /**
     */
    icon?: string;
    /**
     */
    tabTemplate?: template | (() => string | TElement);
    /**
     */
    title?: string;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxTabPanelOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxTabPanelOptions;
