/**
* DevExtreme (ui/tag_box.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import dxSelectBox, {
    dxSelectBoxOptions
} from './select_box';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTagBoxOptions extends dxSelectBoxOptions<dxTagBox> {
    /**
     */
    applyValueMode?: 'instantly' | 'useButtons';
    /**
     */
    hideSelectedItems?: boolean;
    /**
     */
    maxDisplayedTags?: number;
    /**
     */
    multiline?: boolean;
    /**
     */
    onMultiTagPreparing?: ((e: { component?: dxTagBox, element?: TElement, model?: any, multiTagElement?: TElement, selectedItems?: Array<string | number | any>, text?: string, cancel?: boolean }) => void);
    /**
     */
    onSelectAllValueChanged?: ((e: { component?: dxTagBox, element?: TElement, model?: any, value?: boolean }) => void);
    /**
     */
    onSelectionChanged?: ((e: { component?: dxTagBox, element?: TElement, model?: any, addedItems?: Array<string | number | any>, removedItems?: Array<string | number | any> }) => void);
    /**
     */
    selectAllMode?: 'allPages' | 'page';
    /**
     */
    selectedItems?: Array<string | number | any>;
    /**
     */
    showDropDownButton?: boolean;
    /**
     */
    maxFilterQueryLength?: number;
    /**
     */
    showMultiTagOnly?: boolean;
    /**
     */
    tagTemplate?: template | ((itemData: any, itemElement: TElement) => string | TElement);
    /**
     */
    value?: Array<string | number | any>;
}
/**
 */
export default class dxTagBox extends dxSelectBox {
    constructor(element: TElement, options?: dxTagBoxOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxTagBoxOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxTagBoxOptions;
