/**
* DevExtreme (ui/text_area.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import dxTextBox, {
    dxTextBoxOptions
} from './text_box';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTextAreaOptions extends dxTextBoxOptions<dxTextArea> {
    /**
     */
    autoResizeEnabled?: boolean;
    /**
     */
    maxHeight?: number | string;
    /**
     */
    minHeight?: number | string;
    /**
     */
    spellcheck?: boolean;
}
/**
 */
export default class dxTextArea extends dxTextBox {
    constructor(element: TElement, options?: dxTextAreaOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxTextAreaOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxTextAreaOptions;
