/**
* DevExtreme (ui/text_box/ui.text_editor.base.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../../core/element';

import {
    TEvent
} from '../../events/index';

import dxButton, {
    dxButtonOptions
} from '../button';

import Editor, {
    EditorOptions
} from '../editor/editor';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTextEditorOptions<T = dxTextEditor> extends EditorOptions<T> {
    /**
     */
    buttons?: Array<string | 'clear' | dxTextEditorButton>;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    inputAttr?: any;
    /**
     */
    mask?: string;
    /**
     */
    maskChar?: string;
    /**
     */
    maskInvalidMessage?: string;
    /**
     */
    maskRules?: any;
    /**
     */
    name?: string;
    /**
     */
    onChange?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onCopy?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onCut?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onEnterKey?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onFocusIn?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onFocusOut?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onInput?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onKeyDown?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     * @deprecated
     */
    onKeyPress?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onKeyUp?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    onPaste?: ((e: { component?: T, element?: TElement, model?: any, event?: TEvent }) => void);
    /**
     */
    placeholder?: string;
    /**
     */
    showClearButton?: boolean;
    /**
     */
    showMaskMode?: 'always' | 'onFocus';
    /**
     */
    spellcheck?: boolean;
    /**
     */
    stylingMode?: 'outlined' | 'underlined' | 'filled';
    /**
     */
    text?: string;
    /**
     */
    useMaskedValue?: boolean;
    /**
     */
    value?: any;
    /**
     */
    valueChangeEvent?: string;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class dxTextEditor extends Editor {
    constructor(element: TElement, options?: dxTextEditorOptions)
    /**
     */
    blur(): void;
    /**
     */
    focus(): void;
    /**
     */
    getButton(name: string): dxButton | undefined;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTextEditorButton {
    /**
     */
    location?: 'after' | 'before';
    /**
     */
    name?: string;
    /**
     */
    options?: dxButtonOptions;
}
