/**
* DevExtreme (ui/tile_view.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTileViewOptions extends CollectionWidgetOptions<dxTileView> {
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    baseItemHeight?: number;
    /**
     */
    baseItemWidth?: number;
    /**
     */
    dataSource?: string | Array<string | dxTileViewItem | any> | DataSource | DataSourceOptions;
    /**
     */
    direction?: 'horizontal' | 'vertical';
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    hoverStateEnabled?: boolean;
    /**
     */
    itemMargin?: number;
    /**
     */
    items?: Array<string | dxTileViewItem | any>;
    /**
     */
    showScrollbar?: boolean;
}
/**
 */
export default class dxTileView extends CollectionWidget {
    constructor(element: TElement, options?: dxTileViewOptions)
    /**
     */
    scrollPosition(): number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTileViewItem extends CollectionWidgetItem {
    /**
     */
    heightRatio?: number;
    /**
     */
    widthRatio?: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxTileViewOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxTileViewOptions;
