/**
* DevExtreme (ui/toolbar.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxToolbarOptions extends CollectionWidgetOptions<dxToolbar> {
    /**
     */
    dataSource?: string | Array<string | dxToolbarItem | any> | DataSource | DataSourceOptions;
    /**
     */
    items?: Array<string | dxToolbarItem | any>;
    /**
     */
    menuItemTemplate?: template | ((itemData: any, itemIndex: number, itemElement: TElement) => string | TElement);
    /**
     * @deprecated
     */
    height?: number | string | (() => number | string);
}
/**
 */
export default class dxToolbar extends CollectionWidget {
    constructor(element: TElement, options?: dxToolbarOptions)
}


/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxToolbarItem extends CollectionWidgetItem {
    /**
     */
    cssClass?: string;
    /**
     */
    locateInMenu?: 'always' | 'auto' | 'never';
    /**
     */
    location?: 'after' | 'before' | 'center';
    /**
     */
    menuItemTemplate?: template | (() => string | TElement);
    /**
     */
    options?: any;
    /**
     */
    showText?: 'always' | 'inMenu';
    /**
     */
    widget?: 'dxAutocomplete' | 'dxButton' | 'dxCheckBox' | 'dxDateBox' | 'dxMenu' | 'dxSelectBox' | 'dxTabs' | 'dxTextBox' | 'dxButtonGroup' | 'dxDropDownButton';
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxToolbarOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxToolbarOptions;
