/**
* DevExtreme (ui/validation_group.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import DOMComponent, {
    DOMComponentOptions
} from '../core/dom_component';

import {
    TPromise
} from '../core/utils/deferred';

import {
    AsyncRule,
    CompareRule,
    CustomRule,
    EmailRule,
    NumericRule,
    PatternRule,
    RangeRule,
    RequiredRule,
    StringLengthRule
} from './validation_rules';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxValidationGroupOptions extends DOMComponentOptions<dxValidationGroup> {
}
/**
 */
export default class dxValidationGroup extends DOMComponent {
    constructor(element: TElement, options?: dxValidationGroupOptions)
    /**
     */
    reset(): void;
    /**
     */
    validate(): dxValidationGroupResult;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxValidationGroupResult {
    /**
     */
    brokenRules?: Array<RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule>;
    /**
     */
    complete?: TPromise<dxValidationGroupResult>;
    /**
     */
    isValid?: boolean;
    /**
     */
    status?: 'valid' | 'invalid' | 'pending';
    /**
     */
    validators?: Array<any>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxValidationGroupOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxValidationGroupOptions;
