/**
* DevExtreme (ui/validator.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import DOMComponent, {
    DOMComponentOptions
} from '../core/dom_component';

import {
    TPromise
} from '../core/utils/deferred';

import {
    AsyncRule,
    CompareRule,
    CustomRule,
    EmailRule,
    NumericRule,
    PatternRule,
    RangeRule,
    RequiredRule,
    StringLengthRule
} from './validation_rules';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxValidatorOptions extends DOMComponentOptions<dxValidator> {
    /**
     */
    adapter?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      applyValidationResults?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      bypass?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      focus?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      getValue?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      reset?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      validationRequestsCallbacks?: Array<Function>
    };
    /**
     */
    name?: string;
    /**
     */
    onValidated?: ((validatedInfo: { name?: string, isValid?: boolean, value?: any, validationRules?: Array<RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule>, brokenRule?: RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule, brokenRules?: Array<RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule>, status?: 'valid' | 'invalid' | 'pending' }) => void);
    /**
     */
    validationGroup?: string;
    /**
     */
    validationRules?: Array<RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule>;
}
/**
 */
export default class dxValidator extends DOMComponent {
    constructor(element: TElement, options?: dxValidatorOptions)
    /**
     */
    focus(): void;
    /**
     */
    reset(): void;
    /**
     */
    validate(): dxValidatorResult;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxValidatorResult {
    /**
     */
    brokenRule?: RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule;
    /**
     */
    brokenRules?: Array<RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule>;
    /**
     */
    complete?: TPromise<dxValidatorResult>;
    /**
     */
    isValid?: boolean;
    /**
     */
    pendingRules?: Array<AsyncRule>;
    /**
     */
    status?: 'valid' | 'invalid' | 'pending';
    /**
     */
    validationRules?: Array<RequiredRule | NumericRule | RangeRule | StringLengthRule | CustomRule | CompareRule | PatternRule | EmailRule | AsyncRule>;
    /**
     */
    value?: any;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxValidatorOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxValidatorOptions;
