/**
* DevExtreme (viz/bullet.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import BaseSparkline, {
    BaseSparklineOptions
} from './sparklines/base_sparkline';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxBulletOptions extends BaseSparklineOptions<dxBullet> {
    /**
     */
    color?: string;
    /**
     */
    endScaleValue?: number;
    /**
     */
    showTarget?: boolean;
    /**
     */
    showZeroLevel?: boolean;
    /**
     */
    startScaleValue?: number;
    /**
     */
    target?: number;
    /**
     */
    targetColor?: string;
    /**
     */
    targetWidth?: number;
    /**
     */
    value?: number;
}
/**
 */
export default class dxBullet extends BaseSparkline {
    constructor(element: TElement, options?: dxBulletOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxBulletOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxBulletOptions;
