/**
* DevExtreme (viz/circular_gauge.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import {
    BaseGauge,
    BaseGaugeOptions,
    BaseGaugeRangeContainer,
    BaseGaugeScale,
    BaseGaugeScaleLabel,
    GaugeIndicator
} from './gauges/base_gauge';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxCircularGaugeOptions extends BaseGaugeOptions<dxCircularGauge> {
    /**
     */
    geometry?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      endAngle?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      startAngle?: number
    };
    /**
     */
    rangeContainer?: dxCircularGaugeRangeContainer;
    /**
     */
    scale?: dxCircularGaugeScale;
    /**
     */
    subvalueIndicator?: GaugeIndicator;
    /**
     */
    valueIndicator?: GaugeIndicator;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxCircularGaugeRangeContainer extends BaseGaugeRangeContainer {
    /**
     * Specifies the orientation of the range container in the CircularGauge UI component.
     */
    orientation?: 'center' | 'inside' | 'outside';
    /**
     * Specifies the range container&apos;s width in pixels.
     */
    width?: number;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxCircularGaugeScale extends BaseGaugeScale {
    /**
     * Specifies common properties for scale labels.
     */
    label?: dxCircularGaugeScaleLabel;
    /**
     * Specifies the orientation of scale ticks.
     */
    orientation?: 'center' | 'inside' | 'outside';
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxCircularGaugeScaleLabel extends BaseGaugeScaleLabel {
    /**
     * Specifies which label to hide in case of overlapping.
     */
    hideFirstOrLast?: 'first' | 'last';
    /**
     * Specifies the spacing between scale labels and ticks.
     */
    indentFromTick?: number;
}
/**
 */
export default class dxCircularGauge extends BaseGauge {
    constructor(element: TElement, options?: dxCircularGaugeOptions)
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxCircularGaugeOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxCircularGaugeOptions;
