/**
* DevExtreme (viz/sparkline.d.ts)
* Version: 21.1.0 (build 21089-0329)
* Build date: Tue Mar 30 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    TElement
} from '../core/element';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import BaseSparkline, {
    BaseSparklineOptions
} from './sparklines/base_sparkline';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSparklineOptions extends BaseSparklineOptions<dxSparkline> {
    /**
     */
    argumentField?: string;
    /**
     */
    barNegativeColor?: string;
    /**
     */
    barPositiveColor?: string;
    /**
     */
    dataSource?: Array<any> | DataSource | DataSourceOptions | string;
    /**
     */
    firstLastColor?: string;
    /**
     */
    ignoreEmptyPoints?: boolean;
    /**
     */
    lineColor?: string;
    /**
     */
    lineWidth?: number;
    /**
     */
    lossColor?: string;
    /**
     */
    maxColor?: string;
    /**
     */
    maxValue?: number;
    /**
     */
    minColor?: string;
    /**
     */
    minValue?: number;
    /**
     */
    pointColor?: string;
    /**
     */
    pointSize?: number;
    /**
     */
    pointSymbol?: 'circle' | 'cross' | 'polygon' | 'square' | 'triangle';
    /**
     */
    showFirstLast?: boolean;
    /**
     */
    showMinMax?: boolean;
    /**
     */
    type?: 'area' | 'bar' | 'line' | 'spline' | 'splinearea' | 'steparea' | 'stepline' | 'winloss';
    /**
     */
    valueField?: string;
    /**
     */
    winColor?: string;
    /**
     */
    winlossThreshold?: number;
}
/**
 */
export default class dxSparkline extends BaseSparkline {
    constructor(element: TElement, options?: dxSparklineOptions)
    getDataSource(): DataSource;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxSparklineOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxSparklineOptions;
